/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/bwlist/ChangePrivilege.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/bwlist/BWUser.hpp"
#include "castor/bwlist/ChangePrivilege.hpp"
#include "castor/bwlist/RequestType.hpp"
#include "castor/stager/Request.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::bwlist::ChangePrivilege::ChangePrivilege() throw() :
  Request(),
  m_isGranted(false),
  m_id(0) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::bwlist::ChangePrivilege::~ChangePrivilege() throw() {
  for (unsigned int i = 0; i < m_usersVector.size(); i++) {
    m_usersVector[i]->setRequest(0);
  }
  m_usersVector.clear();
  for (unsigned int i = 0; i < m_requestTypesVector.size(); i++) {
    m_requestTypesVector[i]->setRequest(0);
  }
  m_requestTypesVector.clear();
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::bwlist::ChangePrivilege::print(std::ostream& stream,
                                            std::string indent,
                                            castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# ChangePrivilege #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Call print on the parent class(es)
  this->castor::stager::Request::print(stream, indent, alreadyPrinted);
  // Output of all members
  stream << indent << "isGranted : " << (m_isGranted ? "Yes" : "No") << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  {
    stream << indent << "Users : " << std::endl;
    int i;
    std::vector<BWUser*>::const_iterator it;
    for (it = m_usersVector.begin(), i = 0;
         it != m_usersVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
  {
    stream << indent << "RequestTypes : " << std::endl;
    int i;
    std::vector<RequestType*>::const_iterator it;
    for (it = m_requestTypesVector.begin(), i = 0;
         it != m_requestTypesVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::bwlist::ChangePrivilege::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::bwlist::ChangePrivilege::TYPE() {
  return OBJ_ChangePrivilege;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::bwlist::ChangePrivilege::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::bwlist::ChangePrivilege::clone() {
  return new ChangePrivilege(*this);
}

