/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/db/cnv/DbStageFileQueryRequestCnv.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "DbStageFileQueryRequestCnv.hpp"
#include "castor/BaseAddress.hpp"
#include "castor/CnvFactory.hpp"
#include "castor/Constants.hpp"
#include "castor/IAddress.hpp"
#include "castor/IClient.hpp"
#include "castor/ICnvSvc.hpp"
#include "castor/IObject.hpp"
#include "castor/VectorAddress.hpp"
#include "castor/db/DbCnvSvc.hpp"
#include "castor/exception/Exception.hpp"
#include "castor/exception/Internal.hpp"
#include "castor/exception/InvalidArgument.hpp"
#include "castor/exception/NoEntry.hpp"
#include "castor/exception/OutOfMemory.hpp"
#include "castor/stager/QueryParameter.hpp"
#include "castor/stager/StageFileQueryRequest.hpp"
#include "castor/stager/SvcClass.hpp"
#include <algorithm>
#include <set>
#include <stdlib.h>
#include <vector>

//------------------------------------------------------------------------------
// Instantiation of a static factory class - should never be used
//------------------------------------------------------------------------------
static castor::CnvFactory<castor::db::cnv::DbStageFileQueryRequestCnv>* s_factoryDbStageFileQueryRequestCnv =
  new castor::CnvFactory<castor::db::cnv::DbStageFileQueryRequestCnv>();

//------------------------------------------------------------------------------
// Static constants initialization
//------------------------------------------------------------------------------
/// SQL statement for request insertion
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_insertStatementString =
"INSERT INTO StageFileQueryRequest (flags, userName, euid, egid, mask, pid, machine, svcClassName, userTag, reqId, creationTime, lastModificationTime, fileName, id, svcClass, client) VALUES (:1,:2,:3,:4,:5,:6,:7,:8,:9,:10,:11,:12,:13,ids_seq.nextval,:14,:15) RETURNING id INTO :16";

/// SQL statement for request deletion
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_deleteStatementString =
"DELETE FROM StageFileQueryRequest WHERE id = :1";

/// SQL statement for request selection
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_selectStatementString =
"SELECT flags, userName, euid, egid, mask, pid, machine, svcClassName, userTag, reqId, creationTime, lastModificationTime, fileName, id, svcClass, client FROM StageFileQueryRequest WHERE id = :1";

/// SQL statement for bulk request selection
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_bulkSelectStatementString =
"DECLARE \
   TYPE CurType IS REF CURSOR RETURN StageFileQueryRequest%ROWTYPE; \
   PROCEDURE bulkSelect(ids IN castor.\"cnumList\", \
                        objs OUT CurType) AS \
   BEGIN \
     FORALL i IN ids.FIRST..ids.LAST \
       INSERT INTO bulkSelectHelper VALUES(ids(i)); \
     OPEN objs FOR SELECT flags, userName, euid, egid, mask, pid, machine, svcClassName, userTag, reqId, creationTime, lastModificationTime, fileName, id, svcClass, client \
                     FROM StageFileQueryRequest t, bulkSelectHelper h \
                    WHERE t.id = h.objId; \
     DELETE FROM bulkSelectHelper; \
   END; \
 BEGIN \
   bulkSelect(:1, :2); \
 END;";

/// SQL statement for request update
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_updateStatementString =
"UPDATE StageFileQueryRequest SET flags = :1, userName = :2, euid = :3, egid = :4, mask = :5, pid = :6, machine = :7, svcClassName = :8, userTag = :9, reqId = :10, lastModificationTime = :11, fileName = :12 WHERE id = :13";

/// SQL statement for type storage
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_storeTypeStatementString =
"INSERT /* StageFileQueryRequest class */ INTO Id2Type (id, type) VALUES (:1, :2)";

/// SQL statement for type deletion
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_deleteTypeStatementString =
"DELETE FROM Id2Type WHERE id = :1";

/// SQL statement for request insertion into newRequests table
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_insertNewReqStatementString =
"INSERT INTO newRequests (id, type, creation) VALUES (:1, :2, SYSDATE)";

/// SQL select statement for member parameters
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_selectQueryParameterStatementString =
"SELECT id FROM QueryParameter WHERE query = :1 FOR UPDATE";

/// SQL delete statement for member parameters
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_deleteQueryParameterStatementString =
"UPDATE QueryParameter SET query = 0 WHERE id = :1";

/// SQL remote update statement for member parameters
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_remoteUpdateQueryParameterStatementString =
"UPDATE QueryParameter SET query = :1 WHERE id = :2";

/// SQL existence statement for member svcClass
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_checkSvcClassExistStatementString =
"SELECT id FROM SvcClass WHERE id = :1";

/// SQL update statement for member svcClass
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_updateSvcClassStatementString =
"UPDATE StageFileQueryRequest SET svcClass = :1 WHERE id = :2";

/// SQL update statement for member client
const std::string castor::db::cnv::DbStageFileQueryRequestCnv::s_updateIClientStatementString =
"UPDATE StageFileQueryRequest SET client = :1 WHERE id = :2";

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::db::cnv::DbStageFileQueryRequestCnv::DbStageFileQueryRequestCnv(castor::ICnvSvc* cnvSvc) :
  DbBaseCnv(cnvSvc),
  m_insertStatement(0),
  m_deleteStatement(0),
  m_selectStatement(0),
  m_bulkSelectStatement(0),
  m_updateStatement(0),
  m_insertNewReqStatement(0),
  m_storeTypeStatement(0),
  m_deleteTypeStatement(0),
  m_selectQueryParameterStatement(0),
  m_deleteQueryParameterStatement(0),
  m_remoteUpdateQueryParameterStatement(0),
  m_checkSvcClassExistStatement(0),
  m_updateSvcClassStatement(0),
  m_updateIClientStatement(0) {}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::db::cnv::DbStageFileQueryRequestCnv::~DbStageFileQueryRequestCnv() throw() {
  reset();
}

//------------------------------------------------------------------------------
// reset
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::reset() throw() {
  //Here we attempt to delete the statements correctly
  // If something goes wrong, we just ignore it
  try {
    if(m_insertStatement) delete m_insertStatement;
    if(m_deleteStatement) delete m_deleteStatement;
    if(m_selectStatement) delete m_selectStatement;
    if(m_bulkSelectStatement) delete m_bulkSelectStatement;
    if(m_updateStatement) delete m_updateStatement;
    if(m_insertNewReqStatement) delete m_insertNewReqStatement;
    if(m_storeTypeStatement) delete m_storeTypeStatement;
    if(m_deleteTypeStatement) delete m_deleteTypeStatement;
    if(m_deleteQueryParameterStatement) delete m_deleteQueryParameterStatement;
    if(m_selectQueryParameterStatement) delete m_selectQueryParameterStatement;
    if(m_remoteUpdateQueryParameterStatement) delete m_remoteUpdateQueryParameterStatement;
    if(m_checkSvcClassExistStatement) delete m_checkSvcClassExistStatement;
    if(m_updateSvcClassStatement) delete m_updateSvcClassStatement;
    if(m_updateIClientStatement) delete m_updateIClientStatement;
  } catch (castor::exception::Exception ignored) {};
  // Now reset all pointers to 0
  m_insertStatement = 0;
  m_deleteStatement = 0;
  m_selectStatement = 0;
  m_bulkSelectStatement = 0;
  m_updateStatement = 0;
  m_insertNewReqStatement = 0;
  m_storeTypeStatement = 0;
  m_deleteTypeStatement = 0;
  m_selectQueryParameterStatement = 0;
  m_deleteQueryParameterStatement = 0;
  m_remoteUpdateQueryParameterStatement = 0;
  m_checkSvcClassExistStatement = 0;
  m_updateSvcClassStatement = 0;
  m_updateIClientStatement = 0;
}

//------------------------------------------------------------------------------
// ObjType
//------------------------------------------------------------------------------
const unsigned int castor::db::cnv::DbStageFileQueryRequestCnv::ObjType() {
  return castor::stager::StageFileQueryRequest::TYPE();
}

//------------------------------------------------------------------------------
// objType
//------------------------------------------------------------------------------
const unsigned int castor::db::cnv::DbStageFileQueryRequestCnv::objType() const {
  return ObjType();
}

//------------------------------------------------------------------------------
// fillRep
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillRep(castor::IAddress* address,
                                                          castor::IObject* object,
                                                          unsigned int type,
                                                          bool endTransaction)
  throw (castor::exception::Exception) {
  castor::stager::StageFileQueryRequest* obj = 
    dynamic_cast<castor::stager::StageFileQueryRequest*>(object);
  try {
    switch (type) {
    case castor::OBJ_QueryParameter :
      fillRepQueryParameter(obj);
      break;
    case castor::OBJ_SvcClass :
      fillRepSvcClass(obj);
      break;
    case castor::OBJ_IClient :
      fillRepIClient(obj);
      break;
    default :
      castor::exception::InvalidArgument ex;
      ex.getMessage() << "fillRep called for type " << type 
                      << " on object of type " << obj->type() 
                      << ". This is meaningless.";
      throw ex;
    }
    if (endTransaction) {
      cnvSvc()->commit();
    }
  } catch (castor::exception::SQLError e) {
    castor::exception::Internal ex;
    ex.getMessage() << "Error in fillRep for type " << type
                    << std::endl << e.getMessage().str() << std::endl;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// fillRepQueryParameter
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillRepQueryParameter(castor::stager::StageFileQueryRequest* obj)
  throw (castor::exception::Exception) {
  // check select statement
  if (0 == m_selectQueryParameterStatement) {
    m_selectQueryParameterStatement = createStatement(s_selectQueryParameterStatementString);
  }
  // Get current database data
  std::set<u_signed64> parametersList;
  m_selectQueryParameterStatement->setUInt64(1, obj->id());
  castor::db::IDbResultSet *rset = m_selectQueryParameterStatement->executeQuery();
  while (rset->next()) {
    parametersList.insert(rset->getUInt64(1));
  }
  delete rset;
  // update parameters and create new ones
  std::vector<castor::IObject*> toBeCreated;
  for (std::vector<castor::stager::QueryParameter*>::iterator it = obj->parameters().begin();
       it != obj->parameters().end();
       it++) {
    if (0 == (*it)->id()) {
      toBeCreated.push_back(*it);
    } else {
      // Check remote update statement
      if (0 == m_remoteUpdateQueryParameterStatement) {
        m_remoteUpdateQueryParameterStatement = createStatement(s_remoteUpdateQueryParameterStatementString);
      }
      // Update remote object
      m_remoteUpdateQueryParameterStatement->setUInt64(1, obj->id());
      m_remoteUpdateQueryParameterStatement->setUInt64(2, (*it)->id());
      m_remoteUpdateQueryParameterStatement->execute();
      std::set<u_signed64>::iterator item;
      if ((item = parametersList.find((*it)->id())) != parametersList.end()) {
        parametersList.erase(item);
      }
    }
  }
  // create new objects
  cnvSvc()->bulkCreateRep(0, toBeCreated, false, OBJ_QryRequest);
  // Delete old links
  for (std::set<u_signed64>::iterator it = parametersList.begin();
       it != parametersList.end();
       it++) {
    if (0 == m_deleteQueryParameterStatement) {
      m_deleteQueryParameterStatement = createStatement(s_deleteQueryParameterStatementString);
    }
    m_deleteQueryParameterStatement->setUInt64(1, *it);
    m_deleteQueryParameterStatement->execute();
  }
}

//------------------------------------------------------------------------------
// fillRepSvcClass
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillRepSvcClass(castor::stager::StageFileQueryRequest* obj)
  throw (castor::exception::Exception) {
  if (0 != obj->svcClass()) {
    // Check checkSvcClassExist statement
    if (0 == m_checkSvcClassExistStatement) {
      m_checkSvcClassExistStatement = createStatement(s_checkSvcClassExistStatementString);
    }
    // retrieve the object from the database
    m_checkSvcClassExistStatement->setUInt64(1, obj->svcClass()->id());
    castor::db::IDbResultSet *rset = m_checkSvcClassExistStatement->executeQuery();
    if (!rset->next()) {
      castor::BaseAddress ad;
      ad.setCnvSvcName("DbCnvSvc");
      ad.setCnvSvcType(castor::SVC_DBCNV);
      cnvSvc()->createRep(&ad, obj->svcClass(), false);
    }
    // Close resultset
    delete rset;
  }
  // Check update statement
  if (0 == m_updateSvcClassStatement) {
    m_updateSvcClassStatement = createStatement(s_updateSvcClassStatementString);
  }
  // Update local object
  m_updateSvcClassStatement->setUInt64(1, 0 == obj->svcClass() ? 0 : obj->svcClass()->id());
  m_updateSvcClassStatement->setUInt64(2, obj->id());
  m_updateSvcClassStatement->execute();
}

//------------------------------------------------------------------------------
// fillRepIClient
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillRepIClient(castor::stager::StageFileQueryRequest* obj)
  throw (castor::exception::Exception) {
  // Check update statement
  if (0 == m_updateIClientStatement) {
    m_updateIClientStatement = createStatement(s_updateIClientStatementString);
  }
  // Update local object
  m_updateIClientStatement->setUInt64(1, 0 == obj->client() ? 0 : obj->client()->id());
  m_updateIClientStatement->setUInt64(2, obj->id());
  m_updateIClientStatement->execute();
}

//------------------------------------------------------------------------------
// fillObj
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillObj(castor::IAddress* address,
                                                          castor::IObject* object,
                                                          unsigned int type,
                                                          bool endTransaction)
  throw (castor::exception::Exception) {
  castor::stager::StageFileQueryRequest* obj = 
    dynamic_cast<castor::stager::StageFileQueryRequest*>(object);
  switch (type) {
  case castor::OBJ_QueryParameter :
    fillObjQueryParameter(obj);
    break;
  case castor::OBJ_SvcClass :
    fillObjSvcClass(obj);
    break;
  case castor::OBJ_IClient :
    fillObjIClient(obj);
    break;
  default :
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "fillObj called on type " << type 
                    << " on object of type " << obj->type() 
                    << ". This is meaningless.";
    throw ex;
  }
  if (endTransaction) {
    cnvSvc()->commit();
  }
}

//------------------------------------------------------------------------------
// fillObjQueryParameter
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillObjQueryParameter(castor::stager::StageFileQueryRequest* obj)
  throw (castor::exception::Exception) {
  // Check select statement
  if (0 == m_selectQueryParameterStatement) {
    m_selectQueryParameterStatement = createStatement(s_selectQueryParameterStatementString);
  }
  // retrieve the object from the database
  std::vector<u_signed64> parametersList;
  m_selectQueryParameterStatement->setUInt64(1, obj->id());
  castor::db::IDbResultSet *rset = m_selectQueryParameterStatement->executeQuery();
  while (rset->next()) {
    parametersList.push_back(rset->getUInt64(1));
  }
  // Close ResultSet
  delete rset;
  // Update objects and mark old ones for deletion
  std::vector<castor::stager::QueryParameter*> toBeDeleted;
  for (std::vector<castor::stager::QueryParameter*>::iterator it = obj->parameters().begin();
       it != obj->parameters().end();
       it++) {
    std::vector<u_signed64>::iterator item =
      std::find(parametersList.begin(), parametersList.end(), (*it)->id());
    if (item == parametersList.end()) {
      toBeDeleted.push_back(*it);
    } else {
      parametersList.erase(item);
      cnvSvc()->updateObj((*it));
    }
  }
  // Delete old objects
  for (std::vector<castor::stager::QueryParameter*>::iterator it = toBeDeleted.begin();
       it != toBeDeleted.end();
       it++) {
    obj->removeParameters(*it);
    (*it)->setQuery(0);
  }
  // Create new objects
  std::vector<castor::IObject*> newParameters =
    cnvSvc()->getObjsFromIds(parametersList, OBJ_QueryParameter);
  for (std::vector<castor::IObject*>::iterator it = newParameters.begin();
       it != newParameters.end();
       it++) {
    castor::stager::QueryParameter* remoteObj = 
      dynamic_cast<castor::stager::QueryParameter*>(*it);
    obj->addParameters(remoteObj);
    remoteObj->setQuery(obj);
  }
}

//------------------------------------------------------------------------------
// fillObjSvcClass
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillObjSvcClass(castor::stager::StageFileQueryRequest* obj)
  throw (castor::exception::Exception) {
  // Check whether the statement is ok
  if (0 == m_selectStatement) {
    m_selectStatement = createStatement(s_selectStatementString);
  }
  // retrieve the object from the database
  m_selectStatement->setUInt64(1, obj->id());
  castor::db::IDbResultSet *rset = m_selectStatement->executeQuery();
  if (!rset->next()) {
    castor::exception::NoEntry ex;
    ex.getMessage() << "No object found for id :" << obj->id();
    throw ex;
  }
  u_signed64 svcClassId = rset->getInt64(15);
  // Close ResultSet
  delete rset;
  // Check whether something should be deleted
  if (0 != obj->svcClass() &&
      (0 == svcClassId ||
       obj->svcClass()->id() != svcClassId)) {
    obj->setSvcClass(0);
  }
  // Update object or create new one
  if (0 != svcClassId) {
    if (0 == obj->svcClass()) {
      obj->setSvcClass
        (dynamic_cast<castor::stager::SvcClass*>
         (cnvSvc()->getObjFromId(svcClassId)));
    } else {
      cnvSvc()->updateObj(obj->svcClass());
    }
  }
}

//------------------------------------------------------------------------------
// fillObjIClient
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::fillObjIClient(castor::stager::StageFileQueryRequest* obj)
  throw (castor::exception::Exception) {
  // Check whether the statement is ok
  if (0 == m_selectStatement) {
    m_selectStatement = createStatement(s_selectStatementString);
  }
  // retrieve the object from the database
  m_selectStatement->setUInt64(1, obj->id());
  castor::db::IDbResultSet *rset = m_selectStatement->executeQuery();
  if (!rset->next()) {
    castor::exception::NoEntry ex;
    ex.getMessage() << "No object found for id :" << obj->id();
    throw ex;
  }
  u_signed64 clientId = rset->getInt64(16);
  // Close ResultSet
  delete rset;
  // Check whether something should be deleted
  if (0 != obj->client() &&
      (0 == clientId ||
       obj->client()->id() != clientId)) {
    obj->setClient(0);
  }
  // Update object or create new one
  if (0 != clientId) {
    if (0 == obj->client()) {
      obj->setClient
        (dynamic_cast<castor::IClient*>
         (cnvSvc()->getObjFromId(clientId)));
    } else {
      cnvSvc()->updateObj(obj->client());
    }
  }
}

//------------------------------------------------------------------------------
// createRep
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::createRep(castor::IAddress* address,
                                                            castor::IObject* object,
                                                            bool endTransaction,
                                                            unsigned int type)
  throw (castor::exception::Exception) {
  castor::stager::StageFileQueryRequest* obj = 
    dynamic_cast<castor::stager::StageFileQueryRequest*>(object);
  // check whether something needs to be done
  if (0 == obj) return;
  if (0 != obj->id()) return;
  try {
    // Check whether the statements are ok
    if (0 == m_insertStatement) {
      m_insertStatement = createStatement(s_insertStatementString);
      m_insertStatement->registerOutParam(16, castor::db::DBTYPE_UINT64);
    }
    if (0 == m_insertNewReqStatement) {
      m_insertNewReqStatement = createStatement(s_insertNewReqStatementString);
    }
    if (0 == m_storeTypeStatement) {
      m_storeTypeStatement = createStatement(s_storeTypeStatementString);
    }
    // Now Save the current object
    m_insertStatement->setUInt64(1, obj->flags());
    m_insertStatement->setString(2, obj->userName());
    m_insertStatement->setInt(3, obj->euid());
    m_insertStatement->setInt(4, obj->egid());
    m_insertStatement->setInt(5, obj->mask());
    m_insertStatement->setInt(6, obj->pid());
    m_insertStatement->setString(7, obj->machine());
    m_insertStatement->setString(8, obj->svcClassName());
    m_insertStatement->setString(9, obj->userTag());
    m_insertStatement->setString(10, obj->reqId());
    m_insertStatement->setInt(11, time(0));
    m_insertStatement->setInt(12, time(0));
    m_insertStatement->setString(13, obj->fileName());
    m_insertStatement->setUInt64(14, (type == OBJ_SvcClass && obj->svcClass() != 0) ? obj->svcClass()->id() : 0);
    m_insertStatement->setUInt64(15, (type == OBJ_IClient && obj->client() != 0) ? obj->client()->id() : 0);
    m_insertStatement->execute();
    obj->setId(m_insertStatement->getUInt64(16));
    m_storeTypeStatement->setUInt64(1, obj->id());
    m_storeTypeStatement->setUInt64(2, obj->type());
    m_storeTypeStatement->execute();
    m_insertNewReqStatement->setUInt64(1, obj->id());
    m_insertNewReqStatement->setUInt64(2, obj->type());
    m_insertNewReqStatement->execute();
    if (endTransaction) {
      cnvSvc()->commit();
    }
  } catch (castor::exception::SQLError e) {
    // Always try to rollback
    try {
      if (endTransaction) cnvSvc()->rollback();
    } catch (castor::exception::Exception ignored) {}
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in insert request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << "Statement was : " << std::endl
                    << s_insertStatementString << std::endl
                    << " and parameters' values were :" << std::endl
                    << "  flags : " << obj->flags() << std::endl
                    << "  userName : " << obj->userName() << std::endl
                    << "  euid : " << obj->euid() << std::endl
                    << "  egid : " << obj->egid() << std::endl
                    << "  mask : " << obj->mask() << std::endl
                    << "  pid : " << obj->pid() << std::endl
                    << "  machine : " << obj->machine() << std::endl
                    << "  svcClassName : " << obj->svcClassName() << std::endl
                    << "  userTag : " << obj->userTag() << std::endl
                    << "  reqId : " << obj->reqId() << std::endl
                    << "  creationTime : " << obj->creationTime() << std::endl
                    << "  lastModificationTime : " << obj->lastModificationTime() << std::endl
                    << "  fileName : " << obj->fileName() << std::endl
                    << "  id : " << obj->id() << std::endl
                    << "  svcClass : " << (obj->svcClass() ? obj->svcClass()->id() : 0) << std::endl
                    << "  client : " << (obj->client() ? obj->client()->id() : 0) << std::endl;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// bulkCreateRep
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::bulkCreateRep(castor::IAddress* address,
                                                                std::vector<castor::IObject*> &objects,
                                                                bool endTransaction,
                                                                unsigned int type)
  throw (castor::exception::Exception) {
  // check whether something needs to be done
  int nb = objects.size();
  if (0 == nb) return;
  // Casts all objects
  std::vector<castor::stager::StageFileQueryRequest*> objs;
  for (int i = 0; i < nb; i++) {
    objs.push_back(dynamic_cast<castor::stager::StageFileQueryRequest*>(objects[i]));
  }
  std::vector<void *> allocMem;
  try {
    // Check whether the statements are ok
    if (0 == m_insertStatement) {
      m_insertStatement = createStatement(s_insertStatementString);
      m_insertStatement->registerOutParam(16, castor::db::DBTYPE_UINT64);
    }
    if (0 == m_insertNewReqStatement) {
      m_insertNewReqStatement = createStatement(s_insertNewReqStatementString);
    }
    if (0 == m_storeTypeStatement) {
      m_storeTypeStatement = createStatement(s_storeTypeStatementString);
    }
    // build the buffers for flags
    double* flagsBuffer = (double*) malloc(nb * sizeof(double));
    if (flagsBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(flagsBuffer);
    unsigned short* flagsBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (flagsBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(flagsBufLens);
    for (int i = 0; i < nb; i++) {
      flagsBuffer[i] = objs[i]->flags();
      flagsBufLens[i] = sizeof(double);
    }
    m_insertStatement->setDataBuffer
      (1, flagsBuffer, castor::db::DBTYPE_UINT64, sizeof(flagsBuffer[0]), flagsBufLens);
    // build the buffers for userName
    unsigned int userNameMaxLen = 0;
    for (int i = 0; i < nb; i++) {
      if (objs[i]->userName().length()+1 > userNameMaxLen)
        userNameMaxLen = objs[i]->userName().length()+1;
    }
    char* userNameBuffer = (char*) calloc(nb, userNameMaxLen);
    if (userNameBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(userNameBuffer);
    unsigned short* userNameBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (userNameBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(userNameBufLens);
    for (int i = 0; i < nb; i++) {
      strncpy(userNameBuffer+(i*userNameMaxLen), objs[i]->userName().c_str(), userNameMaxLen);
      userNameBufLens[i] = objs[i]->userName().length()+1; // + 1 for the trailing \0
    }
    m_insertStatement->setDataBuffer
      (2, userNameBuffer, castor::db::DBTYPE_STRING, userNameMaxLen, userNameBufLens);
    // build the buffers for euid
    long* euidBuffer = (long*) malloc(nb * sizeof(long));
    if (euidBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(euidBuffer);
    unsigned short* euidBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (euidBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(euidBufLens);
    for (int i = 0; i < nb; i++) {
      euidBuffer[i] = objs[i]->euid();
      euidBufLens[i] = sizeof(long);
    }
    m_insertStatement->setDataBuffer
      (3, euidBuffer, castor::db::DBTYPE_INT, sizeof(euidBuffer[0]), euidBufLens);
    // build the buffers for egid
    long* egidBuffer = (long*) malloc(nb * sizeof(long));
    if (egidBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(egidBuffer);
    unsigned short* egidBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (egidBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(egidBufLens);
    for (int i = 0; i < nb; i++) {
      egidBuffer[i] = objs[i]->egid();
      egidBufLens[i] = sizeof(long);
    }
    m_insertStatement->setDataBuffer
      (4, egidBuffer, castor::db::DBTYPE_INT, sizeof(egidBuffer[0]), egidBufLens);
    // build the buffers for mask
    long* maskBuffer = (long*) malloc(nb * sizeof(long));
    if (maskBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(maskBuffer);
    unsigned short* maskBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (maskBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(maskBufLens);
    for (int i = 0; i < nb; i++) {
      maskBuffer[i] = objs[i]->mask();
      maskBufLens[i] = sizeof(long);
    }
    m_insertStatement->setDataBuffer
      (5, maskBuffer, castor::db::DBTYPE_INT, sizeof(maskBuffer[0]), maskBufLens);
    // build the buffers for pid
    long* pidBuffer = (long*) malloc(nb * sizeof(long));
    if (pidBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(pidBuffer);
    unsigned short* pidBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (pidBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(pidBufLens);
    for (int i = 0; i < nb; i++) {
      pidBuffer[i] = objs[i]->pid();
      pidBufLens[i] = sizeof(long);
    }
    m_insertStatement->setDataBuffer
      (6, pidBuffer, castor::db::DBTYPE_INT, sizeof(pidBuffer[0]), pidBufLens);
    // build the buffers for machine
    unsigned int machineMaxLen = 0;
    for (int i = 0; i < nb; i++) {
      if (objs[i]->machine().length()+1 > machineMaxLen)
        machineMaxLen = objs[i]->machine().length()+1;
    }
    char* machineBuffer = (char*) calloc(nb, machineMaxLen);
    if (machineBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(machineBuffer);
    unsigned short* machineBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (machineBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(machineBufLens);
    for (int i = 0; i < nb; i++) {
      strncpy(machineBuffer+(i*machineMaxLen), objs[i]->machine().c_str(), machineMaxLen);
      machineBufLens[i] = objs[i]->machine().length()+1; // + 1 for the trailing \0
    }
    m_insertStatement->setDataBuffer
      (7, machineBuffer, castor::db::DBTYPE_STRING, machineMaxLen, machineBufLens);
    // build the buffers for svcClassName
    unsigned int svcClassNameMaxLen = 0;
    for (int i = 0; i < nb; i++) {
      if (objs[i]->svcClassName().length()+1 > svcClassNameMaxLen)
        svcClassNameMaxLen = objs[i]->svcClassName().length()+1;
    }
    char* svcClassNameBuffer = (char*) calloc(nb, svcClassNameMaxLen);
    if (svcClassNameBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(svcClassNameBuffer);
    unsigned short* svcClassNameBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (svcClassNameBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(svcClassNameBufLens);
    for (int i = 0; i < nb; i++) {
      strncpy(svcClassNameBuffer+(i*svcClassNameMaxLen), objs[i]->svcClassName().c_str(), svcClassNameMaxLen);
      svcClassNameBufLens[i] = objs[i]->svcClassName().length()+1; // + 1 for the trailing \0
    }
    m_insertStatement->setDataBuffer
      (8, svcClassNameBuffer, castor::db::DBTYPE_STRING, svcClassNameMaxLen, svcClassNameBufLens);
    // build the buffers for userTag
    unsigned int userTagMaxLen = 0;
    for (int i = 0; i < nb; i++) {
      if (objs[i]->userTag().length()+1 > userTagMaxLen)
        userTagMaxLen = objs[i]->userTag().length()+1;
    }
    char* userTagBuffer = (char*) calloc(nb, userTagMaxLen);
    if (userTagBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(userTagBuffer);
    unsigned short* userTagBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (userTagBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(userTagBufLens);
    for (int i = 0; i < nb; i++) {
      strncpy(userTagBuffer+(i*userTagMaxLen), objs[i]->userTag().c_str(), userTagMaxLen);
      userTagBufLens[i] = objs[i]->userTag().length()+1; // + 1 for the trailing \0
    }
    m_insertStatement->setDataBuffer
      (9, userTagBuffer, castor::db::DBTYPE_STRING, userTagMaxLen, userTagBufLens);
    // build the buffers for reqId
    unsigned int reqIdMaxLen = 0;
    for (int i = 0; i < nb; i++) {
      if (objs[i]->reqId().length()+1 > reqIdMaxLen)
        reqIdMaxLen = objs[i]->reqId().length()+1;
    }
    char* reqIdBuffer = (char*) calloc(nb, reqIdMaxLen);
    if (reqIdBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(reqIdBuffer);
    unsigned short* reqIdBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (reqIdBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(reqIdBufLens);
    for (int i = 0; i < nb; i++) {
      strncpy(reqIdBuffer+(i*reqIdMaxLen), objs[i]->reqId().c_str(), reqIdMaxLen);
      reqIdBufLens[i] = objs[i]->reqId().length()+1; // + 1 for the trailing \0
    }
    m_insertStatement->setDataBuffer
      (10, reqIdBuffer, castor::db::DBTYPE_STRING, reqIdMaxLen, reqIdBufLens);
    // build the buffers for creationTime
    double* creationTimeBuffer = (double*) malloc(nb * sizeof(double));
    if (creationTimeBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(creationTimeBuffer);
    unsigned short* creationTimeBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (creationTimeBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(creationTimeBufLens);
    for (int i = 0; i < nb; i++) {
      creationTimeBuffer[i] = time(0);
      creationTimeBufLens[i] = sizeof(double);
    }
    m_insertStatement->setDataBuffer
      (11, creationTimeBuffer, castor::db::DBTYPE_UINT64, sizeof(creationTimeBuffer[0]), creationTimeBufLens);
    // build the buffers for lastModificationTime
    double* lastModificationTimeBuffer = (double*) malloc(nb * sizeof(double));
    if (lastModificationTimeBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(lastModificationTimeBuffer);
    unsigned short* lastModificationTimeBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (lastModificationTimeBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(lastModificationTimeBufLens);
    for (int i = 0; i < nb; i++) {
      lastModificationTimeBuffer[i] = time(0);
      lastModificationTimeBufLens[i] = sizeof(double);
    }
    m_insertStatement->setDataBuffer
      (12, lastModificationTimeBuffer, castor::db::DBTYPE_UINT64, sizeof(lastModificationTimeBuffer[0]), lastModificationTimeBufLens);
    // build the buffers for fileName
    unsigned int fileNameMaxLen = 0;
    for (int i = 0; i < nb; i++) {
      if (objs[i]->fileName().length()+1 > fileNameMaxLen)
        fileNameMaxLen = objs[i]->fileName().length()+1;
    }
    char* fileNameBuffer = (char*) calloc(nb, fileNameMaxLen);
    if (fileNameBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(fileNameBuffer);
    unsigned short* fileNameBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (fileNameBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(fileNameBufLens);
    for (int i = 0; i < nb; i++) {
      strncpy(fileNameBuffer+(i*fileNameMaxLen), objs[i]->fileName().c_str(), fileNameMaxLen);
      fileNameBufLens[i] = objs[i]->fileName().length()+1; // + 1 for the trailing \0
    }
    m_insertStatement->setDataBuffer
      (13, fileNameBuffer, castor::db::DBTYPE_STRING, fileNameMaxLen, fileNameBufLens);
    // build the buffers for svcClass
    double* svcClassBuffer = (double*) malloc(nb * sizeof(double));
    if (svcClassBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(svcClassBuffer);
    unsigned short* svcClassBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (svcClassBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(svcClassBufLens);
    for (int i = 0; i < nb; i++) {
      svcClassBuffer[i] = (type == OBJ_SvcClass && objs[i]->svcClass() != 0) ? objs[i]->svcClass()->id() : 0;
      svcClassBufLens[i] = sizeof(double);
    }
    m_insertStatement->setDataBuffer
      (14, svcClassBuffer, castor::db::DBTYPE_UINT64, sizeof(svcClassBuffer[0]), svcClassBufLens);
    // build the buffers for client
    double* clientBuffer = (double*) malloc(nb * sizeof(double));
    if (clientBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(clientBuffer);
    unsigned short* clientBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (clientBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(clientBufLens);
    for (int i = 0; i < nb; i++) {
      clientBuffer[i] = (type == OBJ_IClient && objs[i]->client() != 0) ? objs[i]->client()->id() : 0;
      clientBufLens[i] = sizeof(double);
    }
    m_insertStatement->setDataBuffer
      (15, clientBuffer, castor::db::DBTYPE_UINT64, sizeof(clientBuffer[0]), clientBufLens);
    // build the buffers for returned ids
    double* idBuffer = (double*) calloc(nb, sizeof(double));
    if (idBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(idBuffer);
    unsigned short* idBufLens = (unsigned short*) calloc(nb, sizeof(unsigned short));
    if (idBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(idBufLens);
    m_insertStatement->setDataBuffer
      (16, idBuffer, castor::db::DBTYPE_UINT64, sizeof(double), idBufLens);
    m_insertStatement->execute(nb);
    for (int i = 0; i < nb; i++) {
      objects[i]->setId((u_signed64)idBuffer[i]);
    }
    // reuse idBuffer for bulk insertion into Id2Type
    m_storeTypeStatement->setDataBuffer
      (1, idBuffer, castor::db::DBTYPE_UINT64, sizeof(idBuffer[0]), idBufLens);
    // build the buffers for type
    int* typeBuffer = (int*) malloc(nb * sizeof(int));
    if (typeBuffer == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(typeBuffer);
    unsigned short* typeBufLens = (unsigned short*) malloc(nb * sizeof(unsigned short));
    if (typeBufLens == 0) {
      castor::exception::OutOfMemory e;
      throw e;
    }
    allocMem.push_back(typeBufLens);
    for (int i = 0; i < nb; i++) {
      typeBuffer[i] = objs[i]->type();
      typeBufLens[i] = sizeof(int);
    }
    m_storeTypeStatement->setDataBuffer
      (2, typeBuffer, castor::db::DBTYPE_INT, sizeof(typeBuffer[0]), typeBufLens);
    m_storeTypeStatement->execute(nb);
    // reuse idBuffer for bulk insertion into NewRequest
    m_insertNewReqStatement->setDataBuffer
      (1, idBuffer, castor::db::DBTYPE_UINT64, sizeof(idBuffer[0]), idBufLens);
    // reuse typeBuffer for bulk insertion into NewRequest
    m_insertNewReqStatement->setDataBuffer
      (2, typeBuffer, castor::db::DBTYPE_INT, sizeof(typeBuffer[0]), typeBufLens);
    m_insertNewReqStatement->execute(nb);
    // release the buffers
    for (unsigned int i = 0; i < allocMem.size(); i++) {
      free(allocMem[i]);
    }
    if (endTransaction) {
      cnvSvc()->commit();
    }
  } catch (castor::exception::SQLError e) {
    // release the buffers
    for (unsigned int i = 0; i < allocMem.size(); i++) {
      free(allocMem[i]);
    }
    // Always try to rollback
    try {
      if (endTransaction) cnvSvc()->rollback();
    } catch (castor::exception::Exception ignored) {}
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in bulkInsert request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << " was called in bulk with "
                    << nb << " items." << std::endl;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// updateRep
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::updateRep(castor::IAddress* address,
                                                            castor::IObject* object,
                                                            bool endTransaction)
  throw (castor::exception::Exception) {
  castor::stager::StageFileQueryRequest* obj = 
    dynamic_cast<castor::stager::StageFileQueryRequest*>(object);
  // check whether something needs to be done
  if (0 == obj) return;
  try {
    // Check whether the statements are ok
    if (0 == m_updateStatement) {
      m_updateStatement = createStatement(s_updateStatementString);
    }
    // Update the current object
    m_updateStatement->setUInt64(1, obj->flags());
    m_updateStatement->setString(2, obj->userName());
    m_updateStatement->setInt(3, obj->euid());
    m_updateStatement->setInt(4, obj->egid());
    m_updateStatement->setInt(5, obj->mask());
    m_updateStatement->setInt(6, obj->pid());
    m_updateStatement->setString(7, obj->machine());
    m_updateStatement->setString(8, obj->svcClassName());
    m_updateStatement->setString(9, obj->userTag());
    m_updateStatement->setString(10, obj->reqId());
    m_updateStatement->setInt(11, time(0));
    m_updateStatement->setString(12, obj->fileName());
    m_updateStatement->setUInt64(13, obj->id());
    m_updateStatement->execute();
    if (endTransaction) {
      cnvSvc()->commit();
    }
  } catch (castor::exception::SQLError e) {
    // Always try to rollback
    try {
      if (endTransaction) cnvSvc()->rollback();
    } catch (castor::exception::Exception ignored) {}
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in update request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << "Statement was : " << std::endl
                    << s_updateStatementString << std::endl
                    << " and id was " << obj->id() << std::endl;;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// deleteRep
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::deleteRep(castor::IAddress* address,
                                                            castor::IObject* object,
                                                            bool endTransaction)
  throw (castor::exception::Exception) {
  castor::stager::StageFileQueryRequest* obj = 
    dynamic_cast<castor::stager::StageFileQueryRequest*>(object);
  // check whether something needs to be done
  if (0 == obj) return;
  try {
    // Check whether the statements are ok
    if (0 == m_deleteStatement) {
      m_deleteStatement = createStatement(s_deleteStatementString);
    }
    if (0 == m_deleteTypeStatement) {
      m_deleteTypeStatement = createStatement(s_deleteTypeStatementString);
    }
    // Now Delete the object
    m_deleteTypeStatement->setUInt64(1, obj->id());
    m_deleteTypeStatement->execute();
    m_deleteStatement->setUInt64(1, obj->id());
    m_deleteStatement->execute();
    for (std::vector<castor::stager::QueryParameter*>::iterator it = obj->parameters().begin();
         it != obj->parameters().end();
         it++) {
      cnvSvc()->deleteRep(0, *it, false);
    }
    if (obj->client() != 0) {
      cnvSvc()->deleteRep(0, obj->client(), false);
    }
    if (endTransaction) {
      cnvSvc()->commit();
    }
  } catch (castor::exception::SQLError e) {
    // Always try to rollback
    try {
      if (endTransaction) cnvSvc()->rollback();
    } catch (castor::exception::Exception ignored) {}
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in delete request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << "Statement was : " << std::endl
                    << s_deleteStatementString << std::endl
                    << " and id was " << obj->id() << std::endl;;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// createObj
//------------------------------------------------------------------------------
castor::IObject* castor::db::cnv::DbStageFileQueryRequestCnv::createObj(castor::IAddress* address)
  throw (castor::exception::Exception) {
  castor::BaseAddress* ad = 
    dynamic_cast<castor::BaseAddress*>(address);
  try {
    // Check whether the statement is ok
    if (0 == m_selectStatement) {
      m_selectStatement = createStatement(s_selectStatementString);
    }
    // retrieve the object from the database
    m_selectStatement->setUInt64(1, ad->target());
    castor::db::IDbResultSet *rset = m_selectStatement->executeQuery();
    if (!rset->next()) {
      castor::exception::NoEntry ex;
      ex.getMessage() << "No object found for id :" << ad->target();
      throw ex;
    }
    // create the new Object
    castor::stager::StageFileQueryRequest* object = new castor::stager::StageFileQueryRequest();
    // Now retrieve and set members
    object->setFlags(rset->getUInt64(1));
    object->setUserName(rset->getString(2));
    object->setEuid(rset->getInt(3));
    object->setEgid(rset->getInt(4));
    object->setMask(rset->getInt(5));
    object->setPid(rset->getInt(6));
    object->setMachine(rset->getString(7));
    object->setSvcClassName(rset->getString(8));
    object->setUserTag(rset->getString(9));
    object->setReqId(rset->getString(10));
    object->setCreationTime(rset->getUInt64(11));
    object->setLastModificationTime(rset->getUInt64(12));
    object->setFileName(rset->getString(13));
    object->setId(rset->getUInt64(14));
    delete rset;
    return object;
  } catch (castor::exception::SQLError e) {
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in select request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << "Statement was : " << std::endl
                    << s_selectStatementString << std::endl
                    << " and id was " << ad->target() << std::endl;;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// bulkCreateObj
//------------------------------------------------------------------------------
std::vector<castor::IObject*>
castor::db::cnv::DbStageFileQueryRequestCnv::bulkCreateObj(castor::IAddress* address)
  throw (castor::exception::Exception) {
  // Prepare result
  std::vector<castor::IObject*> res;
  // check whether something needs to be done
  castor::VectorAddress* ad = 
    dynamic_cast<castor::VectorAddress*>(address);
  int nb = ad->target().size();
  if (0 == nb) return res;
  try {
    // Check whether the statement is ok
    if (0 == m_bulkSelectStatement) {
      m_bulkSelectStatement = createStatement(s_bulkSelectStatementString);
      m_bulkSelectStatement->registerOutParam(2, castor::db::DBTYPE_CURSOR);
    }
    // set the buffer for input ids
    m_bulkSelectStatement->setDataBufferUInt64Array(1, ad->target());
    // Execute statement
    m_bulkSelectStatement->execute();
    // get the result, that is a cursor on the selected rows
    castor::db::IDbResultSet *rset =
      m_bulkSelectStatement->getCursor(2);
    // loop and create the new objects
    bool status = rset->next();
    while (status) {
      // create the new Object
      castor::stager::StageFileQueryRequest* object = new castor::stager::StageFileQueryRequest();
      // Now retrieve and set members
      object->setFlags(rset->getUInt64(1));
      object->setUserName(rset->getString(2));
      object->setEuid(rset->getInt(3));
      object->setEgid(rset->getInt(4));
      object->setMask(rset->getInt(5));
      object->setPid(rset->getInt(6));
      object->setMachine(rset->getString(7));
      object->setSvcClassName(rset->getString(8));
      object->setUserTag(rset->getString(9));
      object->setReqId(rset->getString(10));
      object->setCreationTime(rset->getUInt64(11));
      object->setLastModificationTime(rset->getUInt64(12));
      object->setFileName(rset->getString(13));
      object->setId(rset->getUInt64(14));
      // store object in results and loop;
      res.push_back(object);
      status = rset->next();
    }
    delete rset;
    return res;
  } catch (castor::exception::SQLError e) {
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in bulkSelect request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << " was called in bulk with "
                    << nb << " items." << std::endl;
    throw ex;
  }
}

//------------------------------------------------------------------------------
// updateObj
//------------------------------------------------------------------------------
void castor::db::cnv::DbStageFileQueryRequestCnv::updateObj(castor::IObject* obj)
  throw (castor::exception::Exception) {
  try {
    // Check whether the statement is ok
    if (0 == m_selectStatement) {
      m_selectStatement = createStatement(s_selectStatementString);
    }
    // retrieve the object from the database
    m_selectStatement->setUInt64(1, obj->id());
    castor::db::IDbResultSet *rset = m_selectStatement->executeQuery();
    if (!rset->next()) {
      castor::exception::NoEntry ex;
      ex.getMessage() << "No object found for id :" << obj->id();
      throw ex;
    }
    // Now retrieve and set members
    castor::stager::StageFileQueryRequest* object = 
      dynamic_cast<castor::stager::StageFileQueryRequest*>(obj);
    object->setFlags(rset->getUInt64(1));
    object->setUserName(rset->getString(2));
    object->setEuid(rset->getInt(3));
    object->setEgid(rset->getInt(4));
    object->setMask(rset->getInt(5));
    object->setPid(rset->getInt(6));
    object->setMachine(rset->getString(7));
    object->setSvcClassName(rset->getString(8));
    object->setUserTag(rset->getString(9));
    object->setReqId(rset->getString(10));
    object->setCreationTime(rset->getUInt64(11));
    object->setLastModificationTime(rset->getUInt64(12));
    object->setFileName(rset->getString(13));
    object->setId(rset->getUInt64(14));
    delete rset;
  } catch (castor::exception::SQLError e) {
    castor::exception::InvalidArgument ex;
    ex.getMessage() << "Error in update request :"
                    << std::endl << e.getMessage().str() << std::endl
                    << "Statement was : " << std::endl
                    << s_updateStatementString << std::endl
                    << " and id was " << obj->id() << std::endl;;
    throw ex;
  }
}

