/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/io/StreamRepackSubRequestCnv.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "StreamRepackSubRequestCnv.hpp"
#include "castor/CnvFactory.hpp"
#include "castor/Constants.hpp"
#include "castor/IAddress.hpp"
#include "castor/ICnvSvc.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectCatalog.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/exception/Exception.hpp"
#include "castor/io/StreamAddress.hpp"
#include "castor/io/StreamBaseCnv.hpp"
#include "castor/io/StreamCnvSvc.hpp"
#include "castor/repack/RepackRequest.hpp"
#include "castor/repack/RepackSegment.hpp"
#include "castor/repack/RepackSubRequest.hpp"
#include "castor/repack/RepackSubRequestStatusCode.hpp"
#include "osdep.h"
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Instantiation of a static factory class - should never be used
//------------------------------------------------------------------------------
static castor::CnvFactory<castor::io::StreamRepackSubRequestCnv>* s_factoryStreamRepackSubRequestCnv =
  new castor::CnvFactory<castor::io::StreamRepackSubRequestCnv>();

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::io::StreamRepackSubRequestCnv::StreamRepackSubRequestCnv(castor::ICnvSvc* cnvSvc) :
 StreamBaseCnv(cnvSvc) {}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::io::StreamRepackSubRequestCnv::~StreamRepackSubRequestCnv() throw() {
}

//------------------------------------------------------------------------------
// ObjType
//------------------------------------------------------------------------------
const unsigned int castor::io::StreamRepackSubRequestCnv::ObjType() {
  return castor::repack::RepackSubRequest::TYPE();
}

//------------------------------------------------------------------------------
// objType
//------------------------------------------------------------------------------
const unsigned int castor::io::StreamRepackSubRequestCnv::objType() const {
  return ObjType();
}

//------------------------------------------------------------------------------
// createRep
//------------------------------------------------------------------------------
void castor::io::StreamRepackSubRequestCnv::createRep(castor::IAddress* address,
                                                      castor::IObject* object,
                                                      bool endTransaction,
                                                      unsigned int type)
  throw (castor::exception::Exception) {
  castor::repack::RepackSubRequest* obj = 
    dynamic_cast<castor::repack::RepackSubRequest*>(object);
  StreamAddress* ad = 
    dynamic_cast<StreamAddress*>(address);
  ad->stream() << obj->type();
  ad->stream() << obj->vid();
  ad->stream() << obj->xsize();
  ad->stream() << obj->filesMigrating();
  ad->stream() << obj->filesStaging();
  ad->stream() << obj->files();
  ad->stream() << obj->filesFailed();
  ad->stream() << obj->cuuid();
  ad->stream() << obj->submitTime();
  ad->stream() << obj->filesStaged();
  ad->stream() << obj->filesFailedSubmit();
  ad->stream() << obj->retryNb();
  ad->stream() << obj->id();
  ad->stream() << obj->status();
}

//------------------------------------------------------------------------------
// createObj
//------------------------------------------------------------------------------
castor::IObject* castor::io::StreamRepackSubRequestCnv::createObj(castor::IAddress* address)
  throw (castor::exception::Exception) {
  StreamAddress* ad = 
    dynamic_cast<StreamAddress*>(address);
  // create the new Object
  castor::repack::RepackSubRequest* object = new castor::repack::RepackSubRequest();
  // Now retrieve and set members
  std::string vid;
  ad->stream() >> vid;
  object->setVid(vid);
  u_signed64 xsize;
  ad->stream() >> xsize;
  object->setXsize(xsize);
  int filesMigrating;
  ad->stream() >> filesMigrating;
  object->setFilesMigrating(filesMigrating);
  int filesStaging;
  ad->stream() >> filesStaging;
  object->setFilesStaging(filesStaging);
  int files;
  ad->stream() >> files;
  object->setFiles(files);
  int filesFailed;
  ad->stream() >> filesFailed;
  object->setFilesFailed(filesFailed);
  std::string cuuid;
  ad->stream() >> cuuid;
  object->setCuuid(cuuid);
  u_signed64 submitTime;
  ad->stream() >> submitTime;
  object->setSubmitTime(submitTime);
  int filesStaged;
  ad->stream() >> filesStaged;
  object->setFilesStaged(filesStaged);
  int filesFailedSubmit;
  ad->stream() >> filesFailedSubmit;
  object->setFilesFailedSubmit(filesFailedSubmit);
  u_signed64 retryNb;
  ad->stream() >> retryNb;
  object->setRetryNb(retryNb);
  u_signed64 id;
  ad->stream() >> id;
  object->setId(id);
  int status;
  ad->stream() >> status;
  object->setStatus((castor::repack::RepackSubRequestStatusCode)status);
  return object;
}

//------------------------------------------------------------------------------
// marshalObject
//------------------------------------------------------------------------------
void castor::io::StreamRepackSubRequestCnv::marshalObject(castor::IObject* object,
                                                          castor::io::StreamAddress* address,
                                                          castor::ObjectSet& alreadyDone)
  throw (castor::exception::Exception) {
  castor::repack::RepackSubRequest* obj = 
    dynamic_cast<castor::repack::RepackSubRequest*>(object);
  if (0 == obj) {
    // Case of a null pointer
    address->stream() << castor::OBJ_Ptr << ((unsigned int)0);
  } else if (alreadyDone.find(obj) == alreadyDone.end()) {
    // Case of a pointer to a non streamed object
    createRep(address, obj, true);
    // Mark object as done
    alreadyDone.insert(obj);
    cnvSvc()->marshalObject(obj->repackrequest(), address, alreadyDone);
    address->stream() << obj->repacksegment().size();
    for (std::vector<castor::repack::RepackSegment*>::iterator it = obj->repacksegment().begin();
         it != obj->repacksegment().end();
         it++) {
      cnvSvc()->marshalObject(*it, address, alreadyDone);
    }
  } else {
    // case of a pointer to an already streamed object
    address->stream() << castor::OBJ_Ptr << alreadyDone[obj];
  }
}

//------------------------------------------------------------------------------
// unmarshalObject
//------------------------------------------------------------------------------
castor::IObject* castor::io::StreamRepackSubRequestCnv::unmarshalObject(castor::io::biniostream& stream,
                                                                        castor::ObjectCatalog& newlyCreated)
  throw (castor::exception::Exception) {
  castor::io::StreamAddress ad(stream, "StreamCnvSvc", castor::SVC_STREAMCNV);
  castor::IObject* object = createObj(&ad);
  // Mark object as created
  newlyCreated.insert(object);
  // Fill object with associations
  castor::repack::RepackSubRequest* obj = 
    dynamic_cast<castor::repack::RepackSubRequest*>(object);
  ad.setObjType(castor::OBJ_INVALID);
  castor::IObject* objRepackrequest = cnvSvc()->unmarshalObject(ad, newlyCreated);
  obj->setRepackrequest(dynamic_cast<castor::repack::RepackRequest*>(objRepackrequest));
  unsigned int repacksegmentNb;
  ad.stream() >> repacksegmentNb;
  for (unsigned int i = 0; i < repacksegmentNb; i++) {
    ad.setObjType(castor::OBJ_INVALID);
    castor::IObject* objRepacksegment = cnvSvc()->unmarshalObject(ad, newlyCreated);
    obj->addRepacksegment(dynamic_cast<castor::repack::RepackSegment*>(objRepacksegment));
  }
  return object;
}

