/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/monitoring/DiskServerMetricsReport.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_MONITORING_DISKSERVERMETRICSREPORT_HPP
#define CASTOR_MONITORING_DISKSERVERMETRICSREPORT_HPP

// Include Files
#include "castor/IObject.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace monitoring {

    // Forward declarations
    class FileSystemMetricsReport;

    /**
     * class DiskServerMetricsReport
     * Contains all metrics of a DiskServer
     */
    class DiskServerMetricsReport : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      DiskServerMetricsReport() throw();

      /**
       * Empty Destructor
       */
      virtual ~DiskServerMetricsReport() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_name
       * Name of the DiskServer
       * @return the value of m_name
       */
      std::string name() const {
        return m_name;
      }

      /**
       * Set the value of m_name
       * Name of the DiskServer
       * @param new_var the new value of m_name
       */
      void setName(std::string new_var) {
        m_name = new_var;
      }

      /**
       * Get the value of m_freeRam
       * The amount of free RAM in bytes
       * @return the value of m_freeRam
       */
      u_signed64 freeRam() const {
        return m_freeRam;
      }

      /**
       * Set the value of m_freeRam
       * The amount of free RAM in bytes
       * @param new_var the new value of m_freeRam
       */
      void setFreeRam(u_signed64 new_var) {
        m_freeRam = new_var;
      }

      /**
       * Get the value of m_freeMemory
       * The amount of free memory in bytes
       * @return the value of m_freeMemory
       */
      u_signed64 freeMemory() const {
        return m_freeMemory;
      }

      /**
       * Set the value of m_freeMemory
       * The amount of free memory in bytes
       * @param new_var the new value of m_freeMemory
       */
      void setFreeMemory(u_signed64 new_var) {
        m_freeMemory = new_var;
      }

      /**
       * Get the value of m_freeSwap
       * The amount of free swap in bytes
       * @return the value of m_freeSwap
       */
      u_signed64 freeSwap() const {
        return m_freeSwap;
      }

      /**
       * Set the value of m_freeSwap
       * The amount of free swap in bytes
       * @param new_var the new value of m_freeSwap
       */
      void setFreeSwap(u_signed64 new_var) {
        m_freeSwap = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Add a FileSystemMetricsReport* object to the m_fileSystemMetricsReportsVector
       * list
       */
      void addFileSystemMetricsReports(FileSystemMetricsReport* add_object) {
        m_fileSystemMetricsReportsVector.push_back(add_object);
      }

      /**
       * Remove a FileSystemMetricsReport* object from m_fileSystemMetricsReportsVector
       */
      void removeFileSystemMetricsReports(FileSystemMetricsReport* remove_object) {
        for (unsigned int i = 0; i < m_fileSystemMetricsReportsVector.size(); i++) {
          FileSystemMetricsReport* item = m_fileSystemMetricsReportsVector[i];
          if (item == remove_object) {
            std::vector<FileSystemMetricsReport*>::iterator it = m_fileSystemMetricsReportsVector.begin() + i;
            m_fileSystemMetricsReportsVector.erase(it);
            return;
          }
        }
      }

      /**
       * Get the list of FileSystemMetricsReport* objects held by
       * m_fileSystemMetricsReportsVector
       * @return list of FileSystemMetricsReport* objects held by
       * m_fileSystemMetricsReportsVector
       */
      std::vector<FileSystemMetricsReport*>& fileSystemMetricsReports() {
        return m_fileSystemMetricsReportsVector;
      }

    private:

      /// Name of the DiskServer
      std::string m_name;

      /// The amount of free RAM in bytes
      u_signed64 m_freeRam;

      /// The amount of free memory in bytes
      u_signed64 m_freeMemory;

      /// The amount of free swap in bytes
      u_signed64 m_freeSwap;

      /// The id of this object
      u_signed64 m_id;

      std::vector<FileSystemMetricsReport*> m_fileSystemMetricsReportsVector;

    }; /* end of class DiskServerMetricsReport */

  } /* end of namespace monitoring */

} /* end of namespace castor */

#endif // CASTOR_MONITORING_DISKSERVERMETRICSREPORT_HPP
