/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/monitoring/DiskServerStateReport.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/monitoring/AdminStatusCodes.hpp"
#include "castor/monitoring/DiskServerStateReport.hpp"
#include "castor/monitoring/FileSystemStateReport.hpp"
#include "castor/stager/DiskServerStatusCode.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::monitoring::DiskServerStateReport::DiskServerStateReport() throw() :
  m_name(""),
  m_ram(0),
  m_memory(0),
  m_swap(0),
  m_id(0),
  m_status(castor::stager::DiskServerStatusCode(0)),
  m_adminStatus(AdminStatusCodes(0)) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::monitoring::DiskServerStateReport::~DiskServerStateReport() throw() {
  for (unsigned int i = 0; i < m_FileSystemStatesReportsVector.size(); i++) {
    m_FileSystemStatesReportsVector[i]->setDiskServer(0);
    delete m_FileSystemStatesReportsVector[i];
  }
  m_FileSystemStatesReportsVector.clear();
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::monitoring::DiskServerStateReport::print(std::ostream& stream,
                                                      std::string indent,
                                                      castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# DiskServerStateReport #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Output of all members
  stream << indent << "name : " << m_name << std::endl;
  stream << indent << "ram : " << m_ram << std::endl;
  stream << indent << "memory : " << m_memory << std::endl;
  stream << indent << "swap : " << m_swap << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  stream << indent << "status : " << castor::stager::DiskServerStatusCodeStrings[m_status] << std::endl;
  stream << indent << "adminStatus : " << AdminStatusCodesStrings[m_adminStatus] << std::endl;
  {
    stream << indent << "FileSystemStatesReports : " << std::endl;
    int i;
    std::vector<FileSystemStateReport*>::const_iterator it;
    for (it = m_FileSystemStatesReportsVector.begin(), i = 0;
         it != m_FileSystemStatesReportsVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::monitoring::DiskServerStateReport::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::monitoring::DiskServerStateReport::TYPE() {
  return OBJ_DiskServerStateReport;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::monitoring::DiskServerStateReport::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::monitoring::DiskServerStateReport::clone() {
  return new DiskServerStateReport(*this);
}

