/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/monitoring/FileSystemMetricsReport.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/monitoring/DiskServerMetricsReport.hpp"
#include "castor/monitoring/FileSystemMetricsReport.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::monitoring::FileSystemMetricsReport::FileSystemMetricsReport() throw() :
  m_writeRate(0),
  m_mountPoint(""),
  m_readRate(0),
  m_nbReadStreams(0),
  m_nbWriteStreams(0),
  m_nbReadWriteStreams(0),
  m_freeSpace(0),
  m_previousReadCounter(0),
  m_previousWriteCounter(0),
  m_lastUpdateTime(0),
  m_nbMigratorStreams(0),
  m_nbRecallerStreams(0),
  m_id(0),
  m_diskServer(0) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::monitoring::FileSystemMetricsReport::~FileSystemMetricsReport() throw() {
  if (0 != m_diskServer) {
    m_diskServer->removeFileSystemMetricsReports(this);
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::monitoring::FileSystemMetricsReport::print(std::ostream& stream,
                                                        std::string indent,
                                                        castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# FileSystemMetricsReport #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Output of all members
  stream << indent << "writeRate : " << m_writeRate << std::endl;
  stream << indent << "mountPoint : " << m_mountPoint << std::endl;
  stream << indent << "readRate : " << m_readRate << std::endl;
  stream << indent << "nbReadStreams : " << m_nbReadStreams << std::endl;
  stream << indent << "nbWriteStreams : " << m_nbWriteStreams << std::endl;
  stream << indent << "nbReadWriteStreams : " << m_nbReadWriteStreams << std::endl;
  stream << indent << "freeSpace : " << m_freeSpace << std::endl;
  stream << indent << "previousReadCounter : " << m_previousReadCounter << std::endl;
  stream << indent << "previousWriteCounter : " << m_previousWriteCounter << std::endl;
  stream << indent << "lastUpdateTime : " << m_lastUpdateTime << std::endl;
  stream << indent << "nbMigratorStreams : " << m_nbMigratorStreams << std::endl;
  stream << indent << "nbRecallerStreams : " << m_nbRecallerStreams << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  stream << indent << "DiskServer : " << std::endl;
  if (0 != m_diskServer) {
    m_diskServer->print(stream, indent + "  ", alreadyPrinted);
  } else {
    stream << indent << "  null" << std::endl;
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::monitoring::FileSystemMetricsReport::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::monitoring::FileSystemMetricsReport::TYPE() {
  return OBJ_FileSystemMetricsReport;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::monitoring::FileSystemMetricsReport::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::monitoring::FileSystemMetricsReport::clone() {
  return new FileSystemMetricsReport(*this);
}

