/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/monitoring/FileSystemStateReport.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_MONITORING_FILESYSTEMSTATEREPORT_HPP
#define CASTOR_MONITORING_FILESYSTEMSTATEREPORT_HPP

// Include Files
#include "castor/IObject.hpp"
#include "castor/monitoring/AdminStatusCodes.hpp"
#include "castor/stager/FileSystemStatusCodes.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace monitoring {

    // Forward declarations
    class DiskServerStateReport;

    /**
     * class FileSystemStateReport
     * Describes the state of the FileSystem
     */
    class FileSystemStateReport : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      FileSystemStateReport() throw();

      /**
       * Empty Destructor
       */
      virtual ~FileSystemStateReport() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_mountPoint
       * The mount point of the FileSystem
       * @return the value of m_mountPoint
       */
      std::string mountPoint() const {
        return m_mountPoint;
      }

      /**
       * Set the value of m_mountPoint
       * The mount point of the FileSystem
       * @param new_var the new value of m_mountPoint
       */
      void setMountPoint(std::string new_var) {
        m_mountPoint = new_var;
      }

      /**
       * Get the value of m_space
       * The total amount of space on this fileSystem in bytes
       * @return the value of m_space
       */
      u_signed64 space() const {
        return m_space;
      }

      /**
       * Set the value of m_space
       * The total amount of space on this fileSystem in bytes
       * @param new_var the new value of m_space
       */
      void setSpace(u_signed64 new_var) {
        m_space = new_var;
      }

      /**
       * Get the value of m_minFreeSpace
       * The fraction of free space under which the garbage collector will run. This
       * number must be < 1
       * @return the value of m_minFreeSpace
       */
      float minFreeSpace() const {
        return m_minFreeSpace;
      }

      /**
       * Set the value of m_minFreeSpace
       * The fraction of free space under which the garbage collector will run. This
       * number must be < 1
       * @param new_var the new value of m_minFreeSpace
       */
      void setMinFreeSpace(float new_var) {
        m_minFreeSpace = new_var;
      }

      /**
       * Get the value of m_maxFreeSpace
       * The fraction of free space that the garbage collector is targeting when
       * liberating space. This number must be < 1
       * @return the value of m_maxFreeSpace
       */
      float maxFreeSpace() const {
        return m_maxFreeSpace;
      }

      /**
       * Set the value of m_maxFreeSpace
       * The fraction of free space that the garbage collector is targeting when
       * liberating space. This number must be < 1
       * @param new_var the new value of m_maxFreeSpace
       */
      void setMaxFreeSpace(float new_var) {
        m_maxFreeSpace = new_var;
      }

      /**
       * Get the value of m_minAllowedFreeSpace
       * The fraction of free space under which we stop scheduling write jobs on the
       * filesystem. This number must be < 1
       * @return the value of m_minAllowedFreeSpace
       */
      float minAllowedFreeSpace() const {
        return m_minAllowedFreeSpace;
      }

      /**
       * Set the value of m_minAllowedFreeSpace
       * The fraction of free space under which we stop scheduling write jobs on the
       * filesystem. This number must be < 1
       * @param new_var the new value of m_minAllowedFreeSpace
       */
      void setMinAllowedFreeSpace(float new_var) {
        m_minAllowedFreeSpace = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Get the value of m_status
       * @return the value of m_status
       */
      castor::stager::FileSystemStatusCodes status() const {
        return m_status;
      }

      /**
       * Set the value of m_status
       * @param new_var the new value of m_status
       */
      void setStatus(castor::stager::FileSystemStatusCodes new_var) {
        m_status = new_var;
      }

      /**
       * Get the value of m_adminStatus
       * @return the value of m_adminStatus
       */
      AdminStatusCodes adminStatus() const {
        return m_adminStatus;
      }

      /**
       * Set the value of m_adminStatus
       * @param new_var the new value of m_adminStatus
       */
      void setAdminStatus(AdminStatusCodes new_var) {
        m_adminStatus = new_var;
      }

      /**
       * Get the value of m_diskServer
       * @return the value of m_diskServer
       */
      DiskServerStateReport* diskServer() const {
        return m_diskServer;
      }

      /**
       * Set the value of m_diskServer
       * @param new_var the new value of m_diskServer
       */
      void setDiskServer(DiskServerStateReport* new_var) {
        m_diskServer = new_var;
      }

    private:

      /// The mount point of the FileSystem
      std::string m_mountPoint;

      /// The total amount of space on this fileSystem in bytes
      u_signed64 m_space;

      /// The fraction of free space under which the garbage collector will run. This number must be < 1
      float m_minFreeSpace;

      /// The fraction of free space that the garbage collector is targeting when liberating space. This number must be < 1
      float m_maxFreeSpace;

      /// The fraction of free space under which we stop scheduling write jobs on the filesystem. This number must be < 1
      float m_minAllowedFreeSpace;

      /// The id of this object
      u_signed64 m_id;

      castor::stager::FileSystemStatusCodes m_status;

      AdminStatusCodes m_adminStatus;

      DiskServerStateReport* m_diskServer;

    }; /* end of class FileSystemStateReport */

  } /* end of namespace monitoring */

} /* end of namespace castor */

#endif // CASTOR_MONITORING_FILESYSTEMSTATEREPORT_HPP
