/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/monitoring/MonitorMessageAck.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/MessageAck.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/monitoring/FileSystemStateAck.hpp"
#include "castor/monitoring/MonitorMessageAck.hpp"
#include "castor/stager/DiskServerStatusCode.hpp"
#include <iostream>
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::monitoring::MonitorMessageAck::MonitorMessageAck() throw() :
  MessageAck(),
  m_diskServerStatus(castor::stager::DiskServerStatusCode(0)) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::monitoring::MonitorMessageAck::~MonitorMessageAck() throw() {
  for (unsigned int i = 0; i < m_ackVector.size(); i++) {
    m_ackVector[i]->setFileSystemStates(0);
    delete m_ackVector[i];
  }
  m_ackVector.clear();
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::monitoring::MonitorMessageAck::print(std::ostream& stream,
                                                  std::string indent,
                                                  castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# MonitorMessageAck #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Call print on the parent class(es)
  this->castor::MessageAck::print(stream, indent, alreadyPrinted);
  alreadyPrinted.insert(this);
  stream << indent << "diskServerStatus : " << castor::stager::DiskServerStatusCodeStrings[m_diskServerStatus] << std::endl;
  {
    stream << indent << "Ack : " << std::endl;
    int i;
    std::vector<FileSystemStateAck*>::const_iterator it;
    for (it = m_ackVector.begin(), i = 0;
         it != m_ackVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::monitoring::MonitorMessageAck::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::monitoring::MonitorMessageAck::TYPE() {
  return OBJ_MonitorMessageAck;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::monitoring::MonitorMessageAck::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::monitoring::MonitorMessageAck::clone() {
  return new MonitorMessageAck(*this);
}

