/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/monitoring/StreamReport.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_MONITORING_STREAMREPORT_HPP
#define CASTOR_MONITORING_STREAMREPORT_HPP

// Include Files
#include "castor/IObject.hpp"
#include "castor/monitoring/StreamDirection.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace monitoring {

    /**
     * class StreamReport
     * Report indicating that a new stream was created or removed on a given
     * fileSystem
     */
    class StreamReport : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      StreamReport() throw();

      /**
       * Empty Destructor
       */
      virtual ~StreamReport() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_created
       * Whether it is a stream creation or removal
       * @return the value of m_created
       */
      bool created() const {
        return m_created;
      }

      /**
       * Set the value of m_created
       * Whether it is a stream creation or removal
       * @param new_var the new value of m_created
       */
      void setCreated(bool new_var) {
        m_created = new_var;
      }

      /**
       * Get the value of m_diskServerName
       * The diskserver concerned
       * @return the value of m_diskServerName
       */
      std::string diskServerName() const {
        return m_diskServerName;
      }

      /**
       * Set the value of m_diskServerName
       * The diskserver concerned
       * @param new_var the new value of m_diskServerName
       */
      void setDiskServerName(std::string new_var) {
        m_diskServerName = new_var;
      }

      /**
       * Get the value of m_mountPoint
       * The mountPoint of the concerned fileSystem
       * @return the value of m_mountPoint
       */
      std::string mountPoint() const {
        return m_mountPoint;
      }

      /**
       * Set the value of m_mountPoint
       * The mountPoint of the concerned fileSystem
       * @param new_var the new value of m_mountPoint
       */
      void setMountPoint(std::string new_var) {
        m_mountPoint = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Get the value of m_direction
       * Direction of the reported stream
       * @return the value of m_direction
       */
      StreamDirection direction() const {
        return m_direction;
      }

      /**
       * Set the value of m_direction
       * Direction of the reported stream
       * @param new_var the new value of m_direction
       */
      void setDirection(StreamDirection new_var) {
        m_direction = new_var;
      }

    private:

      /// Whether it is a stream creation or removal
      bool m_created;

      /// The diskserver concerned
      std::string m_diskServerName;

      /// The mountPoint of the concerned fileSystem
      std::string m_mountPoint;

      /// The id of this object
      u_signed64 m_id;

      /// Direction of the reported stream
      StreamDirection m_direction;

    }; /* end of class StreamReport */

  } /* end of namespace monitoring */

} /* end of namespace castor */

#endif // CASTOR_MONITORING_STREAMREPORT_HPP
