.TH RMADMINNODE 1 "$Date: 2009/07/23 12:21:58 $" CASTOR "stager catalogue administrative commands"
.SH NAME
rmAdminNode \- handle statuses in rmMaster
.SH SYNOPSIS
.B rmAdminNode
[
.BI -h,
.BI --help
]
[
.BI -o,
.BI --host " rmMasterHost"
]
[
.BI -p
.BI --port " rmMasterPort"
]
.BI -n,
.BI --node " nodeName"
[
.BI -f,
.BI --force " state"
|
.BI -r,
.BI --release
|
.BI -d,
.BI --delete
]
[
.BI -m,
.BI --mountPoint " fileSystemMountPoint"
]
[
.BI -R,
.BI --recursive
]
.LP
.SH DESCRIPTION
.B rmAdminNode
can be used to force and release the status of diskServers and filesystems
in the monitoring system. It can also delete nodes and filesystems.
Depending on the options, one can either force,
release or delete a diskServer, a fileSystem status or a diskServer and
all its fileSystems (recursive mode).
.TP 16
.BI \-h,\-\-help
Get usage information
.TP
.BI -o,--host " rmMasterHost"
Specified the rmmaster daemon host to use. Default is taken from castor.conf.
.TP
.BI -p,--port " rmMasterPort"
Specifies the rmmaster daemon port to use. Default is taken from castor.conf.
.TP
.BI \-n,\-\-node " nodeName"
Name of the diskServer concerned. Mandatory.
.TP
.BI \-f,\-\-force " state"
Forces the diskServer/filesystem into a given state. This state will stay until
the next call to rmAdminNode for this item.
.TP
.BI \-r,\-\-release
Releases the state of the diskServer/filesystem. The state will now be taken
from the regular monitoring. If a diskserver was previously deleted, it can be
reinstated using this option.
.TP
.BI \-d,\-\-delete
Deletes the diskServer/filesystem from the stager DB and marks it as deleted in
the monitoring system. The diskServer/filesystem will only disappear from the
monitoring at the next reset of the monitoring system.
.TP
.BI \-m,\-\-mountPoint " fileSystemMountPoint"
is the mountPoint of the fileSystem concerned in case you want to modify the states of a filesystem
and not the one of the diskServer itself
.TP
.BI \-R,\-\-recursive
allows to deal with a diskserver and all its fileSystems in one go
.LP
.SH POSSIBLE STATES
.TP 12
.BI "Production"
This is the default when no state is given and means that the diskServer/FileSystem is ready for operation
.TP
.BI "Draining"
This means that the diskServer/FileSystem is not accepting user requests anymore but is still available for
migrations
.TP
.BI "Disabled"
In this state, the diskServer is not used at all by the system.
.LP
.SH EXIT STATUS
This program returns 0 if the operation was successful or > 0 if the operation
failed.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
