/******************************************************************************
 *                      DiskServerStatus.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * Describes the status of one disk server
 *
 * @author Sebastien Ponce
 *****************************************************************************/

// Include files
#include "castor/rmmaster/DiskServerStatus.hpp"
#include <iostream>


//-----------------------------------------------------------------------------
// Constructor
//-----------------------------------------------------------------------------
castor::rmmaster::DiskServerStatus::DiskServerStatus
(u_signed64 id) : m_id(id) { }


//-----------------------------------------------------------------------------
// Print
//-----------------------------------------------------------------------------
void castor::rmmaster::DiskServerStatus::print(std::ostream& out) throw() {
  out << "[" << m_id << "]" << std::endl;
  if (0 == size()) {
    out << "No filesystem" << std::endl;
  } else {
    for (iterator it = begin(); it != end(); it++) {
      out << it->first;
      it->second.print(out);
    }
  }
}
