/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/repack/RepackSegment.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/repack/RepackSegment.hpp"
#include "castor/repack/RepackSubRequest.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::repack::RepackSegment::RepackSegment() throw() :
  m_fileid(0),
  m_segsize(0),
  m_compression(0),
  m_filesec(0),
  m_copyno(0),
  m_blockid(0),
  m_fileseq(0),
  m_errorCode(0),
  m_errorMessage(""),
  m_id(0),
  m_repacksubrequest(0) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::repack::RepackSegment::~RepackSegment() throw() {
  if (0 != m_repacksubrequest) {
    m_repacksubrequest->removeRepacksegment(this);
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::repack::RepackSegment::print(std::ostream& stream,
                                          std::string indent,
                                          castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# RepackSegment #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Output of all members
  stream << indent << "fileid : " << m_fileid << std::endl;
  stream << indent << "segsize : " << m_segsize << std::endl;
  stream << indent << "compression : " << m_compression << std::endl;
  stream << indent << "filesec : " << m_filesec << std::endl;
  stream << indent << "copyno : " << m_copyno << std::endl;
  stream << indent << "blockid : " << m_blockid << std::endl;
  stream << indent << "fileseq : " << m_fileseq << std::endl;
  stream << indent << "errorCode : " << m_errorCode << std::endl;
  stream << indent << "errorMessage : " << m_errorMessage << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  stream << indent << "Repacksubrequest : " << std::endl;
  if (0 != m_repacksubrequest) {
    m_repacksubrequest->print(stream, indent + "  ", alreadyPrinted);
  } else {
    stream << indent << "  null" << std::endl;
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::repack::RepackSegment::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::repack::RepackSegment::TYPE() {
  return OBJ_RepackSegment;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::repack::RepackSegment::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::repack::RepackSegment::clone() {
  return new RepackSegment(*this);
}

