/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/repack/RepackSubRequest.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/repack/RepackRequest.hpp"
#include "castor/repack/RepackSegment.hpp"
#include "castor/repack/RepackSubRequest.hpp"
#include "castor/repack/RepackSubRequestStatusCode.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::repack::RepackSubRequest::RepackSubRequest() throw() :
  m_vid(""),
  m_xsize(0),
  m_filesMigrating(0),
  m_filesStaging(0),
  m_files(0),
  m_filesFailed(0),
  m_cuuid(""),
  m_submitTime(0),
  m_filesStaged(0),
  m_filesFailedSubmit(0),
  m_retryNb(0),
  m_id(0),
  m_repackrequest(0),
  m_status(RepackSubRequestStatusCode(0)) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::repack::RepackSubRequest::~RepackSubRequest() throw() {
  if (0 != m_repackrequest) {
    m_repackrequest->removeRepacksubrequest(this);
  }
  for (unsigned int i = 0; i < m_repacksegmentVector.size(); i++) {
    m_repacksegmentVector[i]->setRepacksubrequest(0);
  }
  m_repacksegmentVector.clear();
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::repack::RepackSubRequest::print(std::ostream& stream,
                                             std::string indent,
                                             castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# RepackSubRequest #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Output of all members
  stream << indent << "vid : " << m_vid << std::endl;
  stream << indent << "xsize : " << m_xsize << std::endl;
  stream << indent << "filesMigrating : " << m_filesMigrating << std::endl;
  stream << indent << "filesStaging : " << m_filesStaging << std::endl;
  stream << indent << "files : " << m_files << std::endl;
  stream << indent << "filesFailed : " << m_filesFailed << std::endl;
  stream << indent << "cuuid : " << m_cuuid << std::endl;
  stream << indent << "submitTime : " << m_submitTime << std::endl;
  stream << indent << "filesStaged : " << m_filesStaged << std::endl;
  stream << indent << "filesFailedSubmit : " << m_filesFailedSubmit << std::endl;
  stream << indent << "retryNb : " << m_retryNb << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  stream << indent << "Repackrequest : " << std::endl;
  if (0 != m_repackrequest) {
    m_repackrequest->print(stream, indent + "  ", alreadyPrinted);
  } else {
    stream << indent << "  null" << std::endl;
  }
  {
    stream << indent << "Repacksegment : " << std::endl;
    int i;
    std::vector<RepackSegment*>::const_iterator it;
    for (it = m_repacksegmentVector.begin(), i = 0;
         it != m_repacksegmentVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
  stream << indent << "status : " << RepackSubRequestStatusCodeStrings[m_status] << std::endl;
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::repack::RepackSubRequest::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::repack::RepackSubRequest::TYPE() {
  return OBJ_RepackSubRequest;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::repack::RepackSubRequest::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::repack::RepackSubRequest::clone() {
  return new RepackSubRequest(*this);
}

