/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/repack/RepackSubRequest.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_REPACK_REPACKSUBREQUEST_HPP
#define CASTOR_REPACK_REPACKSUBREQUEST_HPP

// Include Files
#include "castor/IObject.hpp"
#include "castor/repack/RepackSubRequestStatusCode.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace repack {

    // Forward declarations
    class RepackSegment;
    class RepackRequest;

    /**
     * class RepackSubRequest
     */
    class RepackSubRequest : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      RepackSubRequest() throw();

      /**
       * Empty Destructor
       */
      virtual ~RepackSubRequest() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_vid
       * @return the value of m_vid
       */
      std::string vid() const {
        return m_vid;
      }

      /**
       * Set the value of m_vid
       * @param new_var the new value of m_vid
       */
      void setVid(std::string new_var) {
        m_vid = new_var;
      }

      /**
       * Get the value of m_xsize
       * @return the value of m_xsize
       */
      u_signed64 xsize() const {
        return m_xsize;
      }

      /**
       * Set the value of m_xsize
       * @param new_var the new value of m_xsize
       */
      void setXsize(u_signed64 new_var) {
        m_xsize = new_var;
      }

      /**
       * Get the value of m_filesMigrating
       * @return the value of m_filesMigrating
       */
      int filesMigrating() const {
        return m_filesMigrating;
      }

      /**
       * Set the value of m_filesMigrating
       * @param new_var the new value of m_filesMigrating
       */
      void setFilesMigrating(int new_var) {
        m_filesMigrating = new_var;
      }

      /**
       * Get the value of m_filesStaging
       * @return the value of m_filesStaging
       */
      int filesStaging() const {
        return m_filesStaging;
      }

      /**
       * Set the value of m_filesStaging
       * @param new_var the new value of m_filesStaging
       */
      void setFilesStaging(int new_var) {
        m_filesStaging = new_var;
      }

      /**
       * Get the value of m_files
       * @return the value of m_files
       */
      int files() const {
        return m_files;
      }

      /**
       * Set the value of m_files
       * @param new_var the new value of m_files
       */
      void setFiles(int new_var) {
        m_files = new_var;
      }

      /**
       * Get the value of m_filesFailed
       * @return the value of m_filesFailed
       */
      int filesFailed() const {
        return m_filesFailed;
      }

      /**
       * Set the value of m_filesFailed
       * @param new_var the new value of m_filesFailed
       */
      void setFilesFailed(int new_var) {
        m_filesFailed = new_var;
      }

      /**
       * Get the value of m_cuuid
       * @return the value of m_cuuid
       */
      std::string cuuid() const {
        return m_cuuid;
      }

      /**
       * Set the value of m_cuuid
       * @param new_var the new value of m_cuuid
       */
      void setCuuid(std::string new_var) {
        m_cuuid = new_var;
      }

      /**
       * Get the value of m_submitTime
       * @return the value of m_submitTime
       */
      u_signed64 submitTime() const {
        return m_submitTime;
      }

      /**
       * Set the value of m_submitTime
       * @param new_var the new value of m_submitTime
       */
      void setSubmitTime(u_signed64 new_var) {
        m_submitTime = new_var;
      }

      /**
       * Get the value of m_filesStaged
       * @return the value of m_filesStaged
       */
      int filesStaged() const {
        return m_filesStaged;
      }

      /**
       * Set the value of m_filesStaged
       * @param new_var the new value of m_filesStaged
       */
      void setFilesStaged(int new_var) {
        m_filesStaged = new_var;
      }

      /**
       * Get the value of m_filesFailedSubmit
       * @return the value of m_filesFailedSubmit
       */
      int filesFailedSubmit() const {
        return m_filesFailedSubmit;
      }

      /**
       * Set the value of m_filesFailedSubmit
       * @param new_var the new value of m_filesFailedSubmit
       */
      void setFilesFailedSubmit(int new_var) {
        m_filesFailedSubmit = new_var;
      }

      /**
       * Get the value of m_retryNb
       * @return the value of m_retryNb
       */
      u_signed64 retryNb() const {
        return m_retryNb;
      }

      /**
       * Set the value of m_retryNb
       * @param new_var the new value of m_retryNb
       */
      void setRetryNb(u_signed64 new_var) {
        m_retryNb = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Get the value of m_repackrequest
       * @return the value of m_repackrequest
       */
      RepackRequest* repackrequest() const {
        return m_repackrequest;
      }

      /**
       * Set the value of m_repackrequest
       * @param new_var the new value of m_repackrequest
       */
      void setRepackrequest(RepackRequest* new_var) {
        m_repackrequest = new_var;
      }

      /**
       * Add a RepackSegment* object to the m_repacksegmentVector list
       */
      void addRepacksegment(RepackSegment* add_object) {
        m_repacksegmentVector.push_back(add_object);
      }

      /**
       * Remove a RepackSegment* object from m_repacksegmentVector
       */
      void removeRepacksegment(RepackSegment* remove_object) {
        for (unsigned int i = 0; i < m_repacksegmentVector.size(); i++) {
          RepackSegment* item = m_repacksegmentVector[i];
          if (item == remove_object) {
            std::vector<RepackSegment*>::iterator it = m_repacksegmentVector.begin() + i;
            m_repacksegmentVector.erase(it);
            return;
          }
        }
      }

      /**
       * Get the list of RepackSegment* objects held by m_repacksegmentVector
       * @return list of RepackSegment* objects held by m_repacksegmentVector
       */
      std::vector<RepackSegment*>& repacksegment() {
        return m_repacksegmentVector;
      }

      /**
       * Get the value of m_status
       * @return the value of m_status
       */
      RepackSubRequestStatusCode status() const {
        return m_status;
      }

      /**
       * Set the value of m_status
       * @param new_var the new value of m_status
       */
      void setStatus(RepackSubRequestStatusCode new_var) {
        m_status = new_var;
      }

    private:

      std::string m_vid;

      u_signed64 m_xsize;

      int m_filesMigrating;

      int m_filesStaging;

      int m_files;

      int m_filesFailed;

      std::string m_cuuid;

      u_signed64 m_submitTime;

      int m_filesStaged;

      int m_filesFailedSubmit;

      u_signed64 m_retryNb;

      /// The id of this object
      u_signed64 m_id;

      RepackRequest* m_repackrequest;

      std::vector<RepackSegment*> m_repacksegmentVector;

      RepackSubRequestStatusCode m_status;

    }; /* end of class RepackSubRequest */

  } /* end of namespace repack */

} /* end of namespace castor */

#endif // CASTOR_REPACK_REPACKSUBREQUEST_HPP
