.\" Copyright (C) 2001-2006 by CERN/IT/FIO/FD
.\" All rights reserved
.\"
.TH "REPACK" "2" "July, 2006" "CASTOR" "vmgr Administrator Commands"
.SH "NAME"
repack \- Move files from tape(s) to other tape destination
.SH "SYNOPSIS"


.B repack [option]

options:
.B
.br
.BI \-V " VID1[:VID2[:VID3... ]] ["\-o " OutputServiceClass ][ "\-m " numberRetry ][" \-c "]["\-n " newPoolName ]
.br
.BI \-P " SourcePoolname"  [\-o " OutputServiceClass ] [" \-m " retryNumber ][ " \-c " ]["\-n " newPoolName ][ " \-o " OutputServiceClass ]
.br
.BI  \-r " VID1[:VID2[:VID3...]]"
.br
.BI \-A " VID1[:VID2[:VID3...]]"
.br
.br
.BI  \-R " VID1[:VID2[:VID3...]]"
.br
.B \-s
.br
.BI \-S " VID1[:VID2[:VID3...]]"
.br
.BI \-x " VID1[:VID2[:VID3...]]"
.br
.BI \-e " VID1[:VID2[:VID3...]]"
.br
.BI \-A " VID1[:VID2[:VID3...]]"
.br
.BI \-a
.br
.BI  \-h

.SH "DESCRIPTION"
.B repack
moves files of active segments from a set of tape(s) to a target tape pool and gives
a status overview of the tapes in the repack system.
Only volumes having
.B FULL
status may be repacked. One can either specify a single volume using
.B \-V
option, a list of volumes by sperating them by ':'
or a given tape pool (option
\fB\-P\fR). repack sends a request to the repack server and returns immediately.
If an error occurs on the server side during the submission an error message
is returned.
The repack server to contact, has to be provided by adding the line

REPACK HOST <hostname>

in the castor config file. Additionally the following environment
variables can be specified to override the default port (6800) and host defaults.

REPACK_HOST=<hostname>
.br
REPACK_PORT=<port>

When the repack process has been successfully completed (FINISHED status), the volume can be
reclaimed using the reclaim command.
.LP
This command requires ADMIN privilege in the Cupv database. In case an error
occurs during a repack, messages can be found on the server side in
/var/log/castor/repackd.log.

.TP
.I VID
The volume visual identifier of the single volume to be repacked.
It must be at most CA_MAXVIDLEN characters long. The status in the VMGR has to be
.BR FULL
.TP
.I OutputServiceClass
The name of the service class which is used for writing back the files to tape.
The tape pool information in this service class is taken by the CASTOR II
migrator to get a destination tape from the VMGR. To write to one specific tape, this
service class has to have a tape pool containing this tape.
.br
.B Note that this service class has to be known by the stager given in the castor config file.
.TP
.I SourcePoolname
The name of the tape pool which is to be repacked . It must be at most CA_MAXPOOLNAMELEN characters long.
The list of pools can be obtained with vmgrlistpool .
.TP
.I retryNumber
Maximum number of automatic retry allowed. If this option is not used the default is zero.
.TP
.I newTapePool
New tapepool in with should be moved the tape after a successful repack.
.TP
.SH "OPTIONS"
\fB\-V\fR
specifies the volumes to repack seperated by :.

\fB\-P\fR
specifies the source pool  to repack

\fB\-o\fR
The service class used for migration (see obove). If none specified, the default is taken from the castor config file on the repack server
machine.

\fB\-S\fR
The stager to be used to do the repack of the tape.

\fB\-r\fR
To restart the repack of the tape which is finished but with failures.

\fB\-R\fR
To abort a repack of a tape.

\fB\-s\fR
Prints information about all tapes in an active repack process.

\fB\-s\fR
Prints information about a given tape in an active repack process.

\fB\-x\fR
Prints detailed information of the given volume. It lists the nameserver information of the files which were on that tape when repack has been started.

\fB\-a\fR
Archives all the FINISHED tapes. They are not listed anymore when the \fB\-s\fR option is
given

\fB\-A\fR
Archives the FINISHED-FAILED tapes given by command line

\fB\-e\fR
For each given tape, it list the error reported by the stager when repack have been issued.

\fB\-m\fR
To set the maximum number of automatic retry which should be issued in case of failure.

\fB\-c\fR
To issue vmgr_reclaim of the tape if repack does not report any failure.

\fB\-n\fR
To change the pool of the tape with the given one ,if repack does not report any failure.

\fB\-h\fR
Help

.SH "EXAMPLE"
.nf
.ft CW
Repack to default service class:
repack \-V L30076

Repack of two tapes to service class alicemdc:
repack \-V L30076:L30077 \-o alicemdc

Repack of a tape pool to service class alicemdc:
repack \-P alicemdc3_9940 \-o alicemdc

.ft
.fi
.SH "EXIT STATUS"
This program returns 0 if the operation was successful or >0 if the operation failed:

.br
0	Ok.
.br
1	An error occured.

.SH KNOWN BUGS
repack -x and repack -e can display maximum 1300 entries.

.SH "SEE ALSO"
.BR Castor_limits(4) ,
.BR Cns_listtape(3) ,
.BR reclaim(1) ,
.BR vmgr_listtape(3) ,
.BR vmgr_querypool(3) ,
.BR vmgr_modifytape(3) ,
.B vmgr_querytape(3)
