.\" Copyright (C) 2001-2006 by CERN/IT/FIO/FD
.\" All rights reserved
.TH "REPACK" "" "July, 2006" "CASTOR" "REPACK"
.SH "NAME"
repackd \- The server part for the CASTOR II Repack system.
.SH "SYNOPSIS"
.B repackd
[
.B \-f
] [
.B \-h
]
[
.B \-S num
] [
.B \-M num
]
[
.B \-c num
] [
.B \-C num
]
[
.B \-W num
] 

.SH "DESCRIPTION"
The repackd accepts connections from repack clients and processes their
requests.  

The following information are neccessary and have to be provided in the 
castor config file or specified in environment variables:

CASTOR config file          | Environment variable
.br
\------------------------------------------------
.br
CNS     HOST <hostname>     | CNS_HOST=<hostname>
.br 
RH      HOST <hostname>     | RH_HOST=<hostname>
.br 
REPACK  PROTOCOL <protocol> | REPACK_PROTOCOL=<protocol>
.br 
REPACK  SVCCLASS <name>     | REPACK_SVCCLASS=<name>

The default port and polling time for the Monitoring service can only be 
changed via the following environment variables:
.br
REPACK_PORT=<port number>
.br 
REPACK_POLLTIME=<time in seconds>


.SH "REQUIREMENTS"
The repackd needs a configured Oracle/MySQL Database with the database 
connection username/password specified as the following in the 
/etc/castor/ORAREPACKCONFIG:
.br
DbCnvSvc        user repack
.br
DbCnvSvc        passwd <DB_PASSWD> 
.br
DbCnvSvc        dbName <DB_NAME>
.br 


NOTE : If the repackd runs with other CASTOR II modules on the same machine
which use also this configuration file, the connection parameters name has to be
seperated through the environment variable CASTOR_INSTANCE.


e.g. in case CASTOR_INSTANCE=Repack the corresponding entry in the
ORAREPACKCONFIG looks like:
.br
DbCnvSvc_Repack        user repack
.br
DbCnvSvc_Repack        passwd <DB_PASSWD>
.br
DbCnvSvc_Repack        dbName <DB_NAME>
.br


The database schema has to be created using the sql scripts from CVS.
The repackd accepts connections on the 62800 port (unless no environment variable is given).



.SH "OPTIONS"
\fB\-f\fR
Runs in foreground, if STAGER_TRACE is set to level 1-3, debug messages can be seen on the console.

\fB\-h\fR
Help

\fB\-S num\fR
Number of RepackFileStager threads (default 1)

\fB\-M num\fR
Number of RepackMonitor threads (default 1)

\fB\-c num\fR
Number of RepackFileChecker threads (default 1)

\fB\-C num\fR
Number of RepackCleaner threads (default 1)

\fB\-W num\fR
Number of RepackWorker threads (default 1)

.SH "EXIT STATUS"
In case of an error <> 0.

.SH "SEE ALSO"
.BR repack






