/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/rh/FileQryResponse.h
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_RH_FILEQRYRESPONSE_H
#define CASTOR_RH_FILEQRYRESPONSE_H

/* Include Files and Forward declarations for the C world */
#include "osdep.h"
struct C_IObject_t;
struct Crh_FileQryResponse_t;
struct Crh_Response_t;

/* --------------------------------------------------------------------------
  This defines a C interface to the following class
// class FileQryResponse
// Response to the FileQueryRequest
  -------------------------------------------------------------------------- */

/**
 * Empty Constructor
 */
int Crh_FileQryResponse_create(struct Crh_FileQryResponse_t** obj);

/**
 * Empty Destructor
 */
int Crh_FileQryResponse_delete(struct Crh_FileQryResponse_t* obj);

/**
 * Cast into Response
 */
struct Crh_Response_t* Crh_FileQryResponse_getResponse(struct Crh_FileQryResponse_t* obj);

/**
 * Dynamic cast from Response
 */
struct Crh_FileQryResponse_t* Crh_FileQryResponse_fromResponse(struct Crh_Response_t* obj);

/**
 * Cast into IObject
 */
struct C_IObject_t* Crh_FileQryResponse_getIObject(struct Crh_FileQryResponse_t* obj);

/**
 * Dynamic cast from IObject
 */
struct Crh_FileQryResponse_t* Crh_FileQryResponse_fromIObject(struct C_IObject_t* obj);

/**
 * Outputs this object in a human readable format
 */
int Crh_FileQryResponse_print(struct Crh_FileQryResponse_t* instance);

/**
 * Gets the type of this kind of objects
 */
int Crh_FileQryResponse_TYPE(int* ret);

/*********************************************/
/* Implementation of Response abstract class */
/*********************************************/

/**
 * Get the value of errorCode
 * The error code in case of error
 */
int Crh_FileQryResponse_errorCode(struct Crh_FileQryResponse_t* instance, unsigned int* var);

/**
 * Set the value of errorCode
 * The error code in case of error
 */
int Crh_FileQryResponse_setErrorCode(struct Crh_FileQryResponse_t* instance, unsigned int new_var);

/**
 * Get the value of errorMessage
 * The error message in case of error
 */
int Crh_FileQryResponse_errorMessage(struct Crh_FileQryResponse_t* instance, const char** var);

/**
 * Set the value of errorMessage
 * The error message in case of error
 */
int Crh_FileQryResponse_setErrorMessage(struct Crh_FileQryResponse_t* instance, const char* new_var);

/**
 * Get the value of reqAssociated
 */
int Crh_FileQryResponse_reqAssociated(struct Crh_FileQryResponse_t* instance, const char** var);

/**
 * Set the value of reqAssociated
 */
int Crh_FileQryResponse_setReqAssociated(struct Crh_FileQryResponse_t* instance, const char* new_var);

/***************************************/
/* Implementation of IObject interface */
/***************************************/

/**
 * Gets the type of the object
 */
int Crh_FileQryResponse_type(struct Crh_FileQryResponse_t* instance,
                             int* ret);

/**
 * virtual method to clone any object
 */
int Crh_FileQryResponse_clone(struct Crh_FileQryResponse_t* instance,
                              struct C_IObject_t* ret);

/**
 * Get the value of fileName
 * Name of the internal file
 */
int Crh_FileQryResponse_fileName(struct Crh_FileQryResponse_t* instance, const char** var);

/**
 * Set the value of fileName
 * Name of the internal file
 */
int Crh_FileQryResponse_setFileName(struct Crh_FileQryResponse_t* instance, const char* new_var);

/**
 * Get the value of castorFileName
 * Name of the castor file as in the nameserver
 */
int Crh_FileQryResponse_castorFileName(struct Crh_FileQryResponse_t* instance, const char** var);

/**
 * Set the value of castorFileName
 * Name of the castor file as in the nameserver
 */
int Crh_FileQryResponse_setCastorFileName(struct Crh_FileQryResponse_t* instance, const char* new_var);

/**
 * Get the value of fileId
 * Castor FileId for this file
 */
int Crh_FileQryResponse_fileId(struct Crh_FileQryResponse_t* instance, u_signed64* var);

/**
 * Set the value of fileId
 * Castor FileId for this file
 */
int Crh_FileQryResponse_setFileId(struct Crh_FileQryResponse_t* instance, u_signed64 new_var);

/**
 * Get the value of status
 * Status of the file
 */
int Crh_FileQryResponse_status(struct Crh_FileQryResponse_t* instance, unsigned int* var);

/**
 * Set the value of status
 * Status of the file
 */
int Crh_FileQryResponse_setStatus(struct Crh_FileQryResponse_t* instance, unsigned int new_var);

/**
 * Get the value of size
 * Size of the file
 */
int Crh_FileQryResponse_size(struct Crh_FileQryResponse_t* instance, u_signed64* var);

/**
 * Set the value of size
 * Size of the file
 */
int Crh_FileQryResponse_setSize(struct Crh_FileQryResponse_t* instance, u_signed64 new_var);

/**
 * Get the value of poolName
 * Name of the pool containing the file
 */
int Crh_FileQryResponse_poolName(struct Crh_FileQryResponse_t* instance, const char** var);

/**
 * Set the value of poolName
 * Name of the pool containing the file
 */
int Crh_FileQryResponse_setPoolName(struct Crh_FileQryResponse_t* instance, const char* new_var);

/**
 * Get the value of creationTime
 * Time of the file creation
 */
int Crh_FileQryResponse_creationTime(struct Crh_FileQryResponse_t* instance, u_signed64* var);

/**
 * Set the value of creationTime
 * Time of the file creation
 */
int Crh_FileQryResponse_setCreationTime(struct Crh_FileQryResponse_t* instance, u_signed64 new_var);

/**
 * Get the value of accessTime
 * Time of the last access to the file
 */
int Crh_FileQryResponse_accessTime(struct Crh_FileQryResponse_t* instance, u_signed64* var);

/**
 * Set the value of accessTime
 * Time of the last access to the file
 */
int Crh_FileQryResponse_setAccessTime(struct Crh_FileQryResponse_t* instance, u_signed64 new_var);

/**
 * Get the value of nbAccesses
 * Number of accesses to the file
 */
int Crh_FileQryResponse_nbAccesses(struct Crh_FileQryResponse_t* instance, unsigned int* var);

/**
 * Set the value of nbAccesses
 * Number of accesses to the file
 */
int Crh_FileQryResponse_setNbAccesses(struct Crh_FileQryResponse_t* instance, unsigned int new_var);

/**
 * Get the value of diskServer
 */
int Crh_FileQryResponse_diskServer(struct Crh_FileQryResponse_t* instance, const char** var);

/**
 * Set the value of diskServer
 */
int Crh_FileQryResponse_setDiskServer(struct Crh_FileQryResponse_t* instance, const char* new_var);

/**
 * Get the value of id
 * The id of this object
 */
int Crh_FileQryResponse_id(struct Crh_FileQryResponse_t* instance, u_signed64* var);

/**
 * Set the value of id
 * The id of this object
 */
int Crh_FileQryResponse_setId(struct Crh_FileQryResponse_t* instance, u_signed64 new_var);

#endif /* CASTOR_RH_FILEQRYRESPONSE_H */
