/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/rh/Response.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_RH_RESPONSE_HPP
#define CASTOR_RH_RESPONSE_HPP

// Include Files
#include "castor/IObject.hpp"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace rh {

    /**
     * class Response
     * The base class for all responses send back to the client
     */
    class Response : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      Response() throw();

      /**
       * Empty Destructor
       */
      virtual ~Response() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Get the value of m_errorCode
       * The error code in case of error
       * @return the value of m_errorCode
       */
      unsigned int errorCode() const {
        return m_errorCode;
      }

      /**
       * Set the value of m_errorCode
       * The error code in case of error
       * @param new_var the new value of m_errorCode
       */
      void setErrorCode(unsigned int new_var) {
        m_errorCode = new_var;
      }

      /**
       * Get the value of m_errorMessage
       * The error message in case of error
       * @return the value of m_errorMessage
       */
      std::string errorMessage() const {
        return m_errorMessage;
      }

      /**
       * Set the value of m_errorMessage
       * The error message in case of error
       * @param new_var the new value of m_errorMessage
       */
      void setErrorMessage(std::string new_var) {
        m_errorMessage = new_var;
      }

      /**
       * Get the value of m_reqAssociated
       * @return the value of m_reqAssociated
       */
      std::string reqAssociated() const {
        return m_reqAssociated;
      }

      /**
       * Set the value of m_reqAssociated
       * @param new_var the new value of m_reqAssociated
       */
      void setReqAssociated(std::string new_var) {
        m_reqAssociated = new_var;
      }

    private:

      /// The error code in case of error
      unsigned int m_errorCode;

      /// The error message in case of error
      std::string m_errorMessage;

      std::string m_reqAssociated;

    }; /* end of class Response */

  } /* end of namespace rh */

} /* end of namespace castor */

#endif // CASTOR_RH_RESPONSE_HPP
