.TH schmod_castor 1castor "$Date: 2009/07/23 12:21:59 $" CASTOR "CASTOR2 LSF Scheduler plugin"
.SH NAME
schmod_castor \- CASTOR2 LSF Scheduler plugin information
.SH DESCRIPTION
The
.B schmod_castor
manpage describes the customized pending reasons given by the two CASTOR2 LSF plugins as seen
when viewing job information through the LSF
.B bjobs
command.
.SH PENDING REASONS
.P
.B 20003
.RS
Host not listed in shared memory.
.P
The scheduler plugins were given a host by LSF which is not registered in the shared memory of
the rmmaster daemon. As the host is not known to CASTOR no jobs are authorized to run there.
.RE
.P
.B 20004
.RS
Diskserver status incorrect.
.P
The diskservers in question are not in the correct state to run the job. For example, the 
diskservers are DISABLED or the filesystems involved in a replication request between machines
are not in a PRODUCTION or STANDBY state.
.RE
.P
.B 20005
.RS
Diskserver is not in the list of requested filesystems.
.P
The submission criteria of the job explicitly lists in the external scheduler options a list
of machines and filesystems which are authorized to run the job. For example:
RFS=lxc2disk01:/srv/castor/01|lxc2disk02:/srv/castor/10|... The diskservers in question have 
been rejected as they are not in the list.
.RE
.P
.B 20006
.RS
Diskserver not of interest.
.P
The diskservers in question were not selected to run the job as they were not considered to be
the best choice.
.RE
.P
.B 20007
.RS
Embedded python interpreter error.
.P
An error occurred executing the contents of the python policy file. Check the scheduler plugin
log file to get more detailed information on why the execution failed.
.RE
.P
.B 20008
.RS
Diskserver in exclusion list.
.P
The diskservers in question are excluded from being able to run the job. For example, in a
replication request diskservers which already have a copy of the file to be replicated are
excluded from running as destination ends for the transfer.

.SH SEE ALSO
lsfintro(1),
jobmanagerd(8),
lsb.modules(5),
bjobs(1),
rmGetNodes(1)
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
