/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/FileSystemCInt.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/IObject.hpp"
#include "castor/monitoring/AdminStatusCodes.hpp"
#include "castor/stager/DiskCopy.hpp"
#include "castor/stager/DiskPool.hpp"
#include "castor/stager/DiskServer.hpp"
#include "castor/stager/FileSystem.hpp"
#include "castor/stager/FileSystemStatusCodes.hpp"
#include "osdep.h"
#include <stdlib.h>
#include <string.h>
#include <vector>

extern "C" {

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_create
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_create(castor::stager::FileSystem** obj) {
    *obj = new castor::stager::FileSystem();
    return 0;
  }
  //----------------------------------------------------------------------------
  // Cstager_FileSystem_delete
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_delete(castor::stager::FileSystem* obj) {
    delete obj;
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_getIObject
  //----------------------------------------------------------------------------
  castor::IObject* Cstager_FileSystem_getIObject(castor::stager::FileSystem* obj) {
    return obj;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_fromIObject
  //----------------------------------------------------------------------------
  castor::stager::FileSystem* Cstager_FileSystem_fromIObject(castor::IObject* obj) {
    return dynamic_cast<castor::stager::FileSystem*>(obj);
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_print
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_print(castor::stager::FileSystem* instance) {
    instance->print();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_TYPE
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_TYPE(int* ret) {
    *ret = castor::stager::FileSystem::TYPE();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_type
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_type(castor::stager::FileSystem* instance,
                              int* ret) {
    *ret = instance->type();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_clone
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_clone(castor::stager::FileSystem* instance,
                               castor::IObject** ret) {
    *ret = instance->clone();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_free
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_free(castor::stager::FileSystem* instance, u_signed64* var) {
    *var = instance->free();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setFree
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setFree(castor::stager::FileSystem* instance, u_signed64 new_var) {
    instance->setFree(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_mountPoint
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_mountPoint(castor::stager::FileSystem* instance, const char** var) {
    *var = instance->mountPoint().c_str();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setMountPoint
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setMountPoint(castor::stager::FileSystem* instance, const char* new_var) {
    std::string snew_var(new_var, strlen(new_var));
    instance->setMountPoint(snew_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_minFreeSpace
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_minFreeSpace(castor::stager::FileSystem* instance, float* var) {
    *var = instance->minFreeSpace();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setMinFreeSpace
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setMinFreeSpace(castor::stager::FileSystem* instance, float new_var) {
    instance->setMinFreeSpace(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_minAllowedFreeSpace
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_minAllowedFreeSpace(castor::stager::FileSystem* instance, float* var) {
    *var = instance->minAllowedFreeSpace();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setMinAllowedFreeSpace
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setMinAllowedFreeSpace(castor::stager::FileSystem* instance, float new_var) {
    instance->setMinAllowedFreeSpace(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_maxFreeSpace
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_maxFreeSpace(castor::stager::FileSystem* instance, float* var) {
    *var = instance->maxFreeSpace();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setMaxFreeSpace
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setMaxFreeSpace(castor::stager::FileSystem* instance, float new_var) {
    instance->setMaxFreeSpace(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_totalSize
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_totalSize(castor::stager::FileSystem* instance, u_signed64* var) {
    *var = instance->totalSize();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setTotalSize
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setTotalSize(castor::stager::FileSystem* instance, u_signed64 new_var) {
    instance->setTotalSize(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_readRate
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_readRate(castor::stager::FileSystem* instance, u_signed64* var) {
    *var = instance->readRate();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setReadRate
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setReadRate(castor::stager::FileSystem* instance, u_signed64 new_var) {
    instance->setReadRate(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_writeRate
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_writeRate(castor::stager::FileSystem* instance, u_signed64* var) {
    *var = instance->writeRate();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setWriteRate
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setWriteRate(castor::stager::FileSystem* instance, u_signed64 new_var) {
    instance->setWriteRate(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_nbReadStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_nbReadStreams(castor::stager::FileSystem* instance, unsigned int* var) {
    *var = instance->nbReadStreams();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setNbReadStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setNbReadStreams(castor::stager::FileSystem* instance, unsigned int new_var) {
    instance->setNbReadStreams(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_nbWriteStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_nbWriteStreams(castor::stager::FileSystem* instance, unsigned int* var) {
    *var = instance->nbWriteStreams();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setNbWriteStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setNbWriteStreams(castor::stager::FileSystem* instance, unsigned int new_var) {
    instance->setNbWriteStreams(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_nbReadWriteStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_nbReadWriteStreams(castor::stager::FileSystem* instance, unsigned int* var) {
    *var = instance->nbReadWriteStreams();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setNbReadWriteStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setNbReadWriteStreams(castor::stager::FileSystem* instance, unsigned int new_var) {
    instance->setNbReadWriteStreams(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_nbMigratorStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_nbMigratorStreams(castor::stager::FileSystem* instance, unsigned int* var) {
    *var = instance->nbMigratorStreams();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setNbMigratorStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setNbMigratorStreams(castor::stager::FileSystem* instance, unsigned int new_var) {
    instance->setNbMigratorStreams(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_nbRecallerStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_nbRecallerStreams(castor::stager::FileSystem* instance, unsigned int* var) {
    *var = instance->nbRecallerStreams();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setNbRecallerStreams
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setNbRecallerStreams(castor::stager::FileSystem* instance, unsigned int new_var) {
    instance->setNbRecallerStreams(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_id
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_id(castor::stager::FileSystem* instance, u_signed64* var) {
    *var = instance->id();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setId
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setId(castor::stager::FileSystem* instance, u_signed64 new_var) {
    instance->setId(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_diskPool
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_diskPool(castor::stager::FileSystem* instance, castor::stager::DiskPool** var) {
    *var = instance->diskPool();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setDiskPool
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setDiskPool(castor::stager::FileSystem* instance, castor::stager::DiskPool* new_var) {
    instance->setDiskPool(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_addCopies
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_addCopies(castor::stager::FileSystem* instance, castor::stager::DiskCopy* obj) {
    instance->addCopies(obj);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_removeCopies
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_removeCopies(castor::stager::FileSystem* instance, castor::stager::DiskCopy* obj) {
    instance->removeCopies(obj);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_copies
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_copies(castor::stager::FileSystem* instance, castor::stager::DiskCopy*** var, int* len) {
    std::vector<castor::stager::DiskCopy*>& result = instance->copies();
    *len = result.size();
    *var = (castor::stager::DiskCopy**) malloc((*len) * sizeof(castor::stager::DiskCopy*));
    for (int i = 0; i < *len; i++) {
      (*var)[i] = result[i];
    }
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_diskserver
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_diskserver(castor::stager::FileSystem* instance, castor::stager::DiskServer** var) {
    *var = instance->diskserver();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setDiskserver
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setDiskserver(castor::stager::FileSystem* instance, castor::stager::DiskServer* new_var) {
    instance->setDiskserver(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_status
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_status(castor::stager::FileSystem* instance, castor::stager::FileSystemStatusCodes* var) {
    *var = instance->status();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setStatus
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setStatus(castor::stager::FileSystem* instance, castor::stager::FileSystemStatusCodes new_var) {
    instance->setStatus(new_var);
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_adminStatus
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_adminStatus(castor::stager::FileSystem* instance, castor::monitoring::AdminStatusCodes* var) {
    *var = instance->adminStatus();
    return 0;
  }

  //----------------------------------------------------------------------------
  // Cstager_FileSystem_setAdminStatus
  //----------------------------------------------------------------------------
  int Cstager_FileSystem_setAdminStatus(castor::stager::FileSystem* instance, castor::monitoring::AdminStatusCodes new_var) {
    instance->setAdminStatus(new_var);
    return 0;
  }

} // End of extern "C"
