/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/FilesDeletionFailed.h
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_STAGER_FILESDELETIONFAILED_H
#define CASTOR_STAGER_FILESDELETIONFAILED_H

/* Include Files and Forward declarations for the C world */
#include "osdep.h"
struct C_IClient_t;
struct C_IObject_t;
struct Cstager_FilesDeletionFailed_t;
struct Cstager_GCFileList_t;
struct Cstager_GCFile_t;
struct Cstager_Request_t;
struct Cstager_SvcClass_t;

/* --------------------------------------------------------------------------
  This defines a C interface to the following class
// class FilesDeletionFailed
// Request for telling the stager which files caused a failure when the GC daemon
// tried to delete them
  -------------------------------------------------------------------------- */

/**
 * Empty Constructor
 */
int Cstager_FilesDeletionFailed_create(struct Cstager_FilesDeletionFailed_t** obj);

/**
 * Empty Destructor
 */
int Cstager_FilesDeletionFailed_delete(struct Cstager_FilesDeletionFailed_t* obj);

/**
 * Cast into GCFileList
 */
struct Cstager_GCFileList_t* Cstager_FilesDeletionFailed_getGCFileList(struct Cstager_FilesDeletionFailed_t* obj);

/**
 * Dynamic cast from GCFileList
 */
struct Cstager_FilesDeletionFailed_t* Cstager_FilesDeletionFailed_fromGCFileList(struct Cstager_GCFileList_t* obj);

/**
 * Cast into Request
 */
struct Cstager_Request_t* Cstager_FilesDeletionFailed_getRequest(struct Cstager_FilesDeletionFailed_t* obj);

/**
 * Dynamic cast from Request
 */
struct Cstager_FilesDeletionFailed_t* Cstager_FilesDeletionFailed_fromRequest(struct Cstager_Request_t* obj);

/**
 * Cast into IObject
 */
struct C_IObject_t* Cstager_FilesDeletionFailed_getIObject(struct Cstager_FilesDeletionFailed_t* obj);

/**
 * Dynamic cast from IObject
 */
struct Cstager_FilesDeletionFailed_t* Cstager_FilesDeletionFailed_fromIObject(struct C_IObject_t* obj);

/**
 * Outputs this object in a human readable format
 */
int Cstager_FilesDeletionFailed_print(struct Cstager_FilesDeletionFailed_t* instance);

/**
 * Gets the type of this kind of objects
 */
int Cstager_FilesDeletionFailed_TYPE(int* ret);

/***********************************************/
/* Implementation of GCFileList abstract class */
/***********************************************/

/**
 * Add a struct Cstager_GCFile_t* object to the files list
 */
int Cstager_FilesDeletionFailed_addFiles(struct Cstager_FilesDeletionFailed_t* instance, struct Cstager_GCFile_t* obj);

/**
 * Remove a struct Cstager_GCFile_t* object from files
 */
int Cstager_FilesDeletionFailed_removeFiles(struct Cstager_FilesDeletionFailed_t* instance, struct Cstager_GCFile_t* obj);

/**
 * Get the list of struct Cstager_GCFile_t* objects held by files. Note that the
 * caller is responsible for the deletion of the returned vector.
 */
int Cstager_FilesDeletionFailed_files(struct Cstager_FilesDeletionFailed_t* instance, struct Cstager_GCFile_t*** var, int* len);

/********************************************/
/* Implementation of Request abstract class */
/********************************************/

/**
 * Get the value of flags
 */
int Cstager_FilesDeletionFailed_flags(struct Cstager_FilesDeletionFailed_t* instance, u_signed64* var);

/**
 * Set the value of flags
 */
int Cstager_FilesDeletionFailed_setFlags(struct Cstager_FilesDeletionFailed_t* instance, u_signed64 new_var);

/**
 * Get the value of userName
 * Name of the user that submitted the request
 */
int Cstager_FilesDeletionFailed_userName(struct Cstager_FilesDeletionFailed_t* instance, const char** var);

/**
 * Set the value of userName
 * Name of the user that submitted the request
 */
int Cstager_FilesDeletionFailed_setUserName(struct Cstager_FilesDeletionFailed_t* instance, const char* new_var);

/**
 * Get the value of euid
 * Id of the user that submitted the request
 */
int Cstager_FilesDeletionFailed_euid(struct Cstager_FilesDeletionFailed_t* instance, unsigned long* var);

/**
 * Set the value of euid
 * Id of the user that submitted the request
 */
int Cstager_FilesDeletionFailed_setEuid(struct Cstager_FilesDeletionFailed_t* instance, unsigned long new_var);

/**
 * Get the value of egid
 * Id of the group of the user that submitted the request
 */
int Cstager_FilesDeletionFailed_egid(struct Cstager_FilesDeletionFailed_t* instance, unsigned long* var);

/**
 * Set the value of egid
 * Id of the group of the user that submitted the request
 */
int Cstager_FilesDeletionFailed_setEgid(struct Cstager_FilesDeletionFailed_t* instance, unsigned long new_var);

/**
 * Get the value of mask
 * Mask for accessing files in the user space
 */
int Cstager_FilesDeletionFailed_mask(struct Cstager_FilesDeletionFailed_t* instance, unsigned long* var);

/**
 * Set the value of mask
 * Mask for accessing files in the user space
 */
int Cstager_FilesDeletionFailed_setMask(struct Cstager_FilesDeletionFailed_t* instance, unsigned long new_var);

/**
 * Get the value of pid
 * Process id of the user process
 */
int Cstager_FilesDeletionFailed_pid(struct Cstager_FilesDeletionFailed_t* instance, unsigned long* var);

/**
 * Set the value of pid
 * Process id of the user process
 */
int Cstager_FilesDeletionFailed_setPid(struct Cstager_FilesDeletionFailed_t* instance, unsigned long new_var);

/**
 * Get the value of machine
 * The machine that submitted the request
 */
int Cstager_FilesDeletionFailed_machine(struct Cstager_FilesDeletionFailed_t* instance, const char** var);

/**
 * Set the value of machine
 * The machine that submitted the request
 */
int Cstager_FilesDeletionFailed_setMachine(struct Cstager_FilesDeletionFailed_t* instance, const char* new_var);

/**
 * Get the value of svcClassName
 */
int Cstager_FilesDeletionFailed_svcClassName(struct Cstager_FilesDeletionFailed_t* instance, const char** var);

/**
 * Set the value of svcClassName
 */
int Cstager_FilesDeletionFailed_setSvcClassName(struct Cstager_FilesDeletionFailed_t* instance, const char* new_var);

/**
 * Get the value of userTag
 * This is a string that the user is free to use. It can be useful to classify and
 * select requests.
 */
int Cstager_FilesDeletionFailed_userTag(struct Cstager_FilesDeletionFailed_t* instance, const char** var);

/**
 * Set the value of userTag
 * This is a string that the user is free to use. It can be useful to classify and
 * select requests.
 */
int Cstager_FilesDeletionFailed_setUserTag(struct Cstager_FilesDeletionFailed_t* instance, const char* new_var);

/**
 * Get the value of reqId
 * The Cuuid identifying the Request, stored as a human readable string
 */
int Cstager_FilesDeletionFailed_reqId(struct Cstager_FilesDeletionFailed_t* instance, const char** var);

/**
 * Set the value of reqId
 * The Cuuid identifying the Request, stored as a human readable string
 */
int Cstager_FilesDeletionFailed_setReqId(struct Cstager_FilesDeletionFailed_t* instance, const char* new_var);

/**
 * Get the value of creationTime
 * Time when the Request was created
 */
int Cstager_FilesDeletionFailed_creationTime(struct Cstager_FilesDeletionFailed_t* instance, u_signed64* var);

/**
 * Set the value of creationTime
 * Time when the Request was created
 */
int Cstager_FilesDeletionFailed_setCreationTime(struct Cstager_FilesDeletionFailed_t* instance, u_signed64 new_var);

/**
 * Get the value of lastModificationTime
 * Time when the request was last modified
 */
int Cstager_FilesDeletionFailed_lastModificationTime(struct Cstager_FilesDeletionFailed_t* instance, u_signed64* var);

/**
 * Set the value of lastModificationTime
 * Time when the request was last modified
 */
int Cstager_FilesDeletionFailed_setLastModificationTime(struct Cstager_FilesDeletionFailed_t* instance, u_signed64 new_var);

/**
 * Get the value of svcClass
 */
int Cstager_FilesDeletionFailed_svcClass(struct Cstager_FilesDeletionFailed_t* instance, struct Cstager_SvcClass_t** var);

/**
 * Set the value of svcClass
 */
int Cstager_FilesDeletionFailed_setSvcClass(struct Cstager_FilesDeletionFailed_t* instance, struct Cstager_SvcClass_t* new_var);

/**
 * Get the value of client
 */
int Cstager_FilesDeletionFailed_client(struct Cstager_FilesDeletionFailed_t* instance, struct C_IClient_t** var);

/**
 * Set the value of client
 */
int Cstager_FilesDeletionFailed_setClient(struct Cstager_FilesDeletionFailed_t* instance, struct C_IClient_t* new_var);

/***************************************/
/* Implementation of IObject interface */
/***************************************/

/**
 * Gets the type of the object
 */
int Cstager_FilesDeletionFailed_type(struct Cstager_FilesDeletionFailed_t* instance,
                                     int* ret);

/**
 * virtual method to clone any object
 */
int Cstager_FilesDeletionFailed_clone(struct Cstager_FilesDeletionFailed_t* instance,
                                      struct C_IObject_t* ret);

/**
 * Get the value of id
 * The id of this object
 */
int Cstager_FilesDeletionFailed_id(struct Cstager_FilesDeletionFailed_t* instance, u_signed64* var);

/**
 * Set the value of id
 * The id of this object
 */
int Cstager_FilesDeletionFailed_setId(struct Cstager_FilesDeletionFailed_t* instance, u_signed64 new_var);

#endif /* CASTOR_STAGER_FILESDELETIONFAILED_H */
