/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/MoverCloseRequest.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_STAGER_MOVERCLOSEREQUEST_HPP
#define CASTOR_STAGER_MOVERCLOSEREQUEST_HPP

// Include Files
#include "castor/stager/Request.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace stager {

    /**
     * class MoverCloseRequest
     * Internal request used when a file was closed in a mover after writing.
     * This request exists to avoid the jobs on the diskservers to handle a connection
     * to the database.
     */
    class MoverCloseRequest : public virtual Request {

    public:

      /**
       * Empty Constructor
       */
      MoverCloseRequest() throw();

      /**
       * Empty Destructor
       */
      virtual ~MoverCloseRequest() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_subReqId
       * The id of the SubRequest for which the file closing took place
       * @return the value of m_subReqId
       */
      u_signed64 subReqId() const {
        return m_subReqId;
      }

      /**
       * Set the value of m_subReqId
       * The id of the SubRequest for which the file closing took place
       * @param new_var the new value of m_subReqId
       */
      void setSubReqId(u_signed64 new_var) {
        m_subReqId = new_var;
      }

      /**
       * Get the value of m_fileSize
       * The actual file of the size, once it was closed
       * @return the value of m_fileSize
       */
      u_signed64 fileSize() const {
        return m_fileSize;
      }

      /**
       * Set the value of m_fileSize
       * The actual file of the size, once it was closed
       * @param new_var the new value of m_fileSize
       */
      void setFileSize(u_signed64 new_var) {
        m_fileSize = new_var;
      }

      /**
       * Get the value of m_timeStamp
       * @return the value of m_timeStamp
       */
      u_signed64 timeStamp() const {
        return m_timeStamp;
      }

      /**
       * Set the value of m_timeStamp
       * @param new_var the new value of m_timeStamp
       */
      void setTimeStamp(u_signed64 new_var) {
        m_timeStamp = new_var;
      }

      /**
       * Get the value of m_fileId
       * The id of the castor file
       * @return the value of m_fileId
       */
      u_signed64 fileId() const {
        return m_fileId;
      }

      /**
       * Set the value of m_fileId
       * The id of the castor file
       * @param new_var the new value of m_fileId
       */
      void setFileId(u_signed64 new_var) {
        m_fileId = new_var;
      }

      /**
       * Get the value of m_nsHost
       * The name server hosting this castor file
       * @return the value of m_nsHost
       */
      std::string nsHost() const {
        return m_nsHost;
      }

      /**
       * Set the value of m_nsHost
       * The name server hosting this castor file
       * @param new_var the new value of m_nsHost
       */
      void setNsHost(std::string new_var) {
        m_nsHost = new_var;
      }

      /**
       * Get the value of m_csumType
       * The checksum type for castor name server database
       * @return the value of m_csumType
       */
      std::string csumType() const {
        return m_csumType;
      }

      /**
       * Set the value of m_csumType
       * The checksum type for castor name server database
       * @param new_var the new value of m_csumType
       */
      void setCsumType(std::string new_var) {
        m_csumType = new_var;
      }

      /**
       * Get the value of m_csumValue
       * The checksum value for castor name server database
       * @return the value of m_csumValue
       */
      std::string csumValue() const {
        return m_csumValue;
      }

      /**
       * Set the value of m_csumValue
       * The checksum value for castor name server database
       * @param new_var the new value of m_csumValue
       */
      void setCsumValue(std::string new_var) {
        m_csumValue = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

    private:

      /// The id of the SubRequest for which the file closing took place
      u_signed64 m_subReqId;

      /// The actual file of the size, once it was closed
      u_signed64 m_fileSize;

      u_signed64 m_timeStamp;

      /// The id of the castor file
      u_signed64 m_fileId;

      /// The name server hosting this castor file
      std::string m_nsHost;

      /// The checksum type for castor name server database
      std::string m_csumType;

      /// The checksum value for castor name server database
      std::string m_csumValue;

      /// The id of this object
      u_signed64 m_id;

    }; /* end of class MoverCloseRequest */

  } /* end of namespace stager */

} /* end of namespace castor */

#endif // CASTOR_STAGER_MOVERCLOSEREQUEST_HPP
