/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/PriorityMap.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_STAGER_PRIORITYMAP_HPP
#define CASTOR_STAGER_PRIORITYMAP_HPP

// Include Files
#include "castor/IObject.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace stager {

    /**
     * class PriorityMap
     */
    class PriorityMap : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      PriorityMap() throw();

      /**
       * Empty Destructor
       */
      virtual ~PriorityMap() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_priority
       * The priority associated with the user and group
       * @return the value of m_priority
       */
      u_signed64 priority() const {
        return m_priority;
      }

      /**
       * Set the value of m_priority
       * The priority associated with the user and group
       * @param new_var the new value of m_priority
       */
      void setPriority(u_signed64 new_var) {
        m_priority = new_var;
      }

      /**
       * Get the value of m_euid
       * The id of the user concerned
       * @return the value of m_euid
       */
      u_signed64 euid() const {
        return m_euid;
      }

      /**
       * Set the value of m_euid
       * The id of the user concerned
       * @param new_var the new value of m_euid
       */
      void setEuid(u_signed64 new_var) {
        m_euid = new_var;
      }

      /**
       * Get the value of m_egid
       * The id of the group concerned
       * @return the value of m_egid
       */
      u_signed64 egid() const {
        return m_egid;
      }

      /**
       * Set the value of m_egid
       * The id of the group concerned
       * @param new_var the new value of m_egid
       */
      void setEgid(u_signed64 new_var) {
        m_egid = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

    private:

      /// The priority associated with the user and group
      u_signed64 m_priority;

      /// The id of the user concerned
      u_signed64 m_euid;

      /// The id of the group concerned
      u_signed64 m_egid;

      /// The id of this object
      u_signed64 m_id;

    }; /* end of class PriorityMap */

  } /* end of namespace stager */

} /* end of namespace castor */

#endif // CASTOR_STAGER_PRIORITYMAP_HPP
