.TH MIGHUNTERD "$Date: 2009/07/23 12:18:45 $" CASTOR "Mighunter"
.SH NAME
mighunterd \- default migration candidate hunter
.SH SYNOPSIS
.B mighunterd
[
.BI -f
]
[
.BI -C
] [ [
.BI -t
.BI sleepTime
] | [ [
.BI -s
.BI streamSleepTime
]
[
.BI -m
.BI migrationSleepTime
] ]
[
.BI -v
.BI dataThreshold
]
[
.BI svcClass1
]
[
.BI svcClass2 ...
]
.SH DESCRIPTION
.B mighunterd
is the default stream creator and migration candidate hunter provided with the CASTOR
stager.
.SH OPTIONS
If no service class names are specified on the command-line then the service class name "default" will be used.
Information and error messages are logged to stdout/stderr.
.TP
.BI \-f
Run the daemon in the foreground.
.TP
.BI \-C
This switch instructs the
.B mighunterd
when creating new streams to always clone an existing stream if it finds one associated
with the service class. The stream cloning can give a load-balancing advantage when new
streams are added to a service class. Be aware, however, that it is an heavy operation
if the existing stream has many (1000s) of migration candidates.
.TP
.BI \-t " sleepTime"
Specifies the single value in seconds to be used for both the sleep time
between two stream-policy database lookups and the sleep time between two
migration-policy database lookups.
If this option is not given then the default value of 7200 seconds (2 hours)
will be used.
The
.BI \-t
option cannot be used in
conjunction with the
.BI \-s
or
.BI \-m
options which allow the stream-policy and migration-policy database lookup
periods to be set independently.
.TP
.BI \-s " streamSleepTime"
Specifies the sleep time in seconds between two stream-policy database lookups.
If this option is not given then the default value of 7200 seconds (2 hours)
will be used.
The
.BI \-s
option cannot be used in conjunction with the
.BI \-t
option.
.TP
.BI \-m " migrationSleepTime"
Specifies the sleep time in seconds between two migration-policy database
lookups.  If this option is not given then the default value of 7200 second
will be used. 
Please only use this option if you really know what you are doing.
The
.BI \-m
option cannot be used in conjunction with the
.BI \-t
option.
.TP
.BI \-v " dataThreshold"
Specifies the minimum amount of data required for starting a new migration.
Note that this option has no effect if there are already running streams for
the service class.

Two parameters in the 
.B /etc/castor/castor.conf 
specify the location of the file where all the policy functions are declared. 

e.g.:

.B MIGHUNTER MIGRATION_POLICY migration

.B MIGHUNTER STREAM_POLICY stream

Then for each svcclass we specify in the database the function that we want to execute between the ones declared in the file.
If no function is specified we act like the policy allows the operation.
If an error is reported by the function we act like a negative response from the policy.


.SH EXAMPLE
.fi
# mighunterd default
.fi
# mighunterd  -t 300 -v 100G alicemdc6

.SH EXIT STATUS
This program returns 0 if the operation was successful or > 0 if the operation
failed.

.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
