/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/DumpParameters.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_TAPE_TAPEGATEWAY_DUMPPARAMETERS_HPP
#define CASTOR_TAPE_TAPEGATEWAY_DUMPPARAMETERS_HPP

// Include Files
#include "castor/tape/tapegateway/GatewayMessage.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace tape {

    namespace tapegateway {

      /**
       * class DumpParameters
       */
      class DumpParameters : public virtual GatewayMessage {

      public:

        /**
         * Empty Constructor
         */
        DumpParameters() throw();

        /**
         * Empty Destructor
         */
        virtual ~DumpParameters() throw();

        /**
         * Outputs this object in a human readable format
         * @param stream The stream where to print this object
         * @param indent The indentation to use
         * @param alreadyPrinted The set of objects already printed.
         * This is to avoid looping when printing circular dependencies
         */
        virtual void print(std::ostream& stream,
                           std::string indent,
                           castor::ObjectSet& alreadyPrinted) const;

        /**
         * Outputs this object in a human readable format
         */
        virtual void print() const;

        /**
         * Gets the type of this kind of objects
         */
        static int TYPE();

        /********************************************/
        /* Implementation of IObject abstract class */
        /********************************************/
        /**
         * Gets the type of the object
         */
        virtual int type() const;

        /**
         * virtual method to clone any object
         */
        virtual castor::IObject* clone();

        /*********************************/
        /* End of IObject abstract class */
        /*********************************/
        /**
         * Get the value of m_maxBytes
         * @return the value of m_maxBytes
         */
        int maxBytes() const {
          return m_maxBytes;
        }

        /**
         * Set the value of m_maxBytes
         * @param new_var the new value of m_maxBytes
         */
        void setMaxBytes(int new_var) {
          m_maxBytes = new_var;
        }

        /**
         * Get the value of m_blockSize
         * @return the value of m_blockSize
         */
        int blockSize() const {
          return m_blockSize;
        }

        /**
         * Set the value of m_blockSize
         * @param new_var the new value of m_blockSize
         */
        void setBlockSize(int new_var) {
          m_blockSize = new_var;
        }

        /**
         * Get the value of m_converter
         * @return the value of m_converter
         */
        int converter() const {
          return m_converter;
        }

        /**
         * Set the value of m_converter
         * @param new_var the new value of m_converter
         */
        void setConverter(int new_var) {
          m_converter = new_var;
        }

        /**
         * Get the value of m_errAction
         * @return the value of m_errAction
         */
        int errAction() const {
          return m_errAction;
        }

        /**
         * Set the value of m_errAction
         * @param new_var the new value of m_errAction
         */
        void setErrAction(int new_var) {
          m_errAction = new_var;
        }

        /**
         * Get the value of m_startFile
         * @return the value of m_startFile
         */
        int startFile() const {
          return m_startFile;
        }

        /**
         * Set the value of m_startFile
         * @param new_var the new value of m_startFile
         */
        void setStartFile(int new_var) {
          m_startFile = new_var;
        }

        /**
         * Get the value of m_maxFile
         * @return the value of m_maxFile
         */
        int maxFile() const {
          return m_maxFile;
        }

        /**
         * Set the value of m_maxFile
         * @param new_var the new value of m_maxFile
         */
        void setMaxFile(int new_var) {
          m_maxFile = new_var;
        }

        /**
         * Get the value of m_fromBlock
         * @return the value of m_fromBlock
         */
        int fromBlock() const {
          return m_fromBlock;
        }

        /**
         * Set the value of m_fromBlock
         * @param new_var the new value of m_fromBlock
         */
        void setFromBlock(int new_var) {
          m_fromBlock = new_var;
        }

        /**
         * Get the value of m_toBlock
         * @return the value of m_toBlock
         */
        int toBlock() const {
          return m_toBlock;
        }

        /**
         * Set the value of m_toBlock
         * @param new_var the new value of m_toBlock
         */
        void setToBlock(int new_var) {
          m_toBlock = new_var;
        }

        /**
         * Get the value of m_id
         * The id of this object
         * @return the value of m_id
         */
        u_signed64 id() const {
          return m_id;
        }

        /**
         * Set the value of m_id
         * The id of this object
         * @param new_var the new value of m_id
         */
        void setId(u_signed64 new_var) {
          m_id = new_var;
        }

      private:

        int m_maxBytes;

        int m_blockSize;

        int m_converter;

        int m_errAction;

        int m_startFile;

        int m_maxFile;

        int m_fromBlock;

        int m_toBlock;

        /// The id of this object
        u_signed64 m_id;

      }; /* end of class DumpParameters */

    } /* end of namespace tapegateway */

  } /* end of namespace tape */

} /* end of namespace castor */

#endif // CASTOR_TAPE_TAPEGATEWAY_DUMPPARAMETERS_HPP
