/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/vdqm/VolumePriority.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @(#)$RCSfile$ $Revision$ $Release$ $Date$ $Author$
 *
 * 
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_VDQM_VOLUMEPRIORITY_HPP
#define CASTOR_VDQM_VOLUMEPRIORITY_HPP

// Include Files
#include "castor/IObject.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace vdqm {

    /**
     * class VolumePriority
     */
    class VolumePriority : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      VolumePriority() throw();

      /**
       * Empty Destructor
       */
      virtual ~VolumePriority() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_priority
       * @return the value of m_priority
       */
      int priority() const {
        return m_priority;
      }

      /**
       * Set the value of m_priority
       * @param new_var the new value of m_priority
       */
      void setPriority(int new_var) {
        m_priority = new_var;
      }

      /**
       * Get the value of m_clientUID
       * @return the value of m_clientUID
       */
      int clientUID() const {
        return m_clientUID;
      }

      /**
       * Set the value of m_clientUID
       * @param new_var the new value of m_clientUID
       */
      void setClientUID(int new_var) {
        m_clientUID = new_var;
      }

      /**
       * Get the value of m_clientGID
       * @return the value of m_clientGID
       */
      int clientGID() const {
        return m_clientGID;
      }

      /**
       * Set the value of m_clientGID
       * @param new_var the new value of m_clientGID
       */
      void setClientGID(int new_var) {
        m_clientGID = new_var;
      }

      /**
       * Get the value of m_clientHost
       * @return the value of m_clientHost
       */
      std::string clientHost() const {
        return m_clientHost;
      }

      /**
       * Set the value of m_clientHost
       * @param new_var the new value of m_clientHost
       */
      void setClientHost(std::string new_var) {
        m_clientHost = new_var;
      }

      /**
       * Get the value of m_vid
       * @return the value of m_vid
       */
      std::string vid() const {
        return m_vid;
      }

      /**
       * Set the value of m_vid
       * @param new_var the new value of m_vid
       */
      void setVid(std::string new_var) {
        m_vid = new_var;
      }

      /**
       * Get the value of m_tpMode
       * @return the value of m_tpMode
       */
      int tpMode() const {
        return m_tpMode;
      }

      /**
       * Set the value of m_tpMode
       * @param new_var the new value of m_tpMode
       */
      void setTpMode(int new_var) {
        m_tpMode = new_var;
      }

      /**
       * Get the value of m_lifespanType
       * @return the value of m_lifespanType
       */
      int lifespanType() const {
        return m_lifespanType;
      }

      /**
       * Set the value of m_lifespanType
       * @param new_var the new value of m_lifespanType
       */
      void setLifespanType(int new_var) {
        m_lifespanType = new_var;
      }

      /**
       * Get the value of m_creationTime
       * @return the value of m_creationTime
       */
      u_signed64 creationTime() const {
        return m_creationTime;
      }

      /**
       * Set the value of m_creationTime
       * @param new_var the new value of m_creationTime
       */
      void setCreationTime(u_signed64 new_var) {
        m_creationTime = new_var;
      }

      /**
       * Get the value of m_modificationTime
       * @return the value of m_modificationTime
       */
      u_signed64 modificationTime() const {
        return m_modificationTime;
      }

      /**
       * Set the value of m_modificationTime
       * @param new_var the new value of m_modificationTime
       */
      void setModificationTime(u_signed64 new_var) {
        m_modificationTime = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

    private:

      int m_priority;

      int m_clientUID;

      int m_clientGID;

      std::string m_clientHost;

      std::string m_vid;

      int m_tpMode;

      int m_lifespanType;

      u_signed64 m_creationTime;

      u_signed64 m_modificationTime;

      /// The id of this object
      u_signed64 m_id;

    }; /* end of class VolumePriority */

  } /* end of namespace vdqm */

} /* end of namespace castor */

#endif // CASTOR_VDQM_VOLUMEPRIORITY_HPP
