.TH dlf_init 3 "CERN IT-DM" CASTOR "DLF Library Functions"
.SH NAME
dlf_init \- initialiZe the DLF logging interface
.SH SYNOPSIS
.B #include "dlf_api.h"

.BI "int dlf_init (const char * " ident, " int " maskpri ")"

.SH DESCRIPTION
.B dlf_init
initializes the DLF (Distributed Logging Facility) interface and must be called
before any other DLF library related functions. All other function calls
relating to the DLF library will fail upon unsuccessful initialization.

The
.I ident
argument defines the name of the facility under which messages should be logged.

The
.I maspri
argument is used to set the log priority mask when logging messages. For more
information refer to
.BR "setlogmask" (3)
If the value is -1, the default mask of LOG_INFO will be used.

.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B errno
is set appropriately.

.SH ERRORS
.TP 1.3i
.B EPERM
The interface is already initialized
.TP
.B EINVAL
Invalid argument (refers to errors in parsing the LogMask configuration option
in castor.conf)

.SH SEE ALSO
.BR dlf_regtext (3),
.BR dlf_shutdown (3),
.BR dlf_write (3),
.BR setlogmask (3)

.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>

