.TH dlf_reqtext 3 "CERN IT-DM" CASTOR "DLF Library Functions"
.SH NAME
dlf_regtext \- registers a message text with the DLF logging interface
.SH SYNOPSIS
.B #include "dlf_api.h"

.BI "int dlf_init (unsigned int " msgno, " const char * " message ")"
.SH DESCRIPTION
.B dlf_regtext
is used to register a message text for the initialized facility. All messages
logged by the DLF interface excluding free text parameters must be
pre-registered.

The registered message text and number will also be logged to syslog using
the LOCAL2/LOG_INFO facility and priority. These messages must be forwarded
to the central DLF server so that they can be registered in the DLF database.

The
.I msgno
argument is the unique message number used to reference the message text.

The
.I message
argument is the text associated with the
.I msgno

.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B errno
is set appropriately.

.SH ERRORS
.TP 1.3i
.B EPERM
The interface is not initialized.
.TP
.B EINVAL
.I message
is a NULL pointer or the length of the
.I message
exceeds
.B DLF_MAX_PARAMSTRLEN
bytes or the
.I msgno
is greater than
.B DLF_MAX_MSGTEXTS
.TP
.B ENOMEM
Out of memory

.SH SEE ALSO
.BR dlf_init (3),
.BR dlf_shutdown (3),
.BR dlf_write (3)

.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>

