.lf 8 expertd.man
.\" @(#)$RCSfile: expertd.man,v $ $Revision: 1.7 $ $Date: 2009/08/18 09:42:59 $ CERN IT-ADC Vitaly Motyakov
.\" Copyright (C) 2004 by CERN/IT/ADC
.\" All rights reserved
.\"
.TH EXPERTD 8 "$Date: 2009/08/18 09:42:59 $" CASTOR "Expert Administrator Commands"
.SH NAME
expertd \- start the CASTOR Expert daemon
.SH SYNOPSIS
.B EXPERTD
.SH DESCRIPTION
.LP
The
.B expertd
command starts the Expert service.
This command is usually executed at system startup time
.RB ( /etc/rc.local ).
This will start the Expert daemon which will look for requests.
When a request arrives the daemon forks a child which processes the request.
The child reads the configuration file and if the request is valid and
can be fulfilled it replaces itself by the external program.
.LP
All error messages are kept in a log, in /var/log/castor/expertd.log.
.LP
The Expert daemon listen port number can be defined on client hosts
and on the machine where the Expert daemon runs in either of the
following ways:
.RS
.LP
setting an environment variable EXPERT_PORT
.RS
.HP
setenv EXPERT_PORT 5045
.RE
.LP
an entry in
.B /etc/castor/castor.conf
like:
.RS
.HP
EXPERT	PORT	5045
.RE
.LP
an entry in
.B /etc/services
like:
.RS
.HP
expert   5045/tcp     # CASTOR Expert
.RE
.RE
.LP
If none of these methods is used, the default port number is taken from the
definition of EXPERT_PORT in expert_constants.h. Currently it is defined as
5045.
.LP
The EXPERT host name can be defined on client hosts
in either of the following ways:
.RS
.LP
setting an environment variable EXPERT_HOST, for example:
.RS
.HP
setenv EXPERT_HOST castorexp
.RE
.LP
an entry in
.B /etc/castor/castor.conf
for example:
.RS
.HP
EXPERT	HOST	castorexp
.RE
.RE
.LP
If none of these methods is used, the default host is taken from the
definition of ExpertHost in site.def.
.LP
The Expert configuration file contains the associations between requests
and command lines which should be executed.The working directory
(i.e. the directory where files are located) should also be specified.
The lines started with hash (#) are considered as comments. The
configuration file line format:
.LP
.B
<request_type><sp><working_directory><sp><command_line>
.LP
where
.TP
.I <request_type>
currently must be one of the following:
.RS
.TP
.B EXP_RQ_FILESYSTEM
.TP
.B EXP_RQ_MIGRATOR
.TP
.B EXP_RQ_RECALLER
.TP
.B EXP_RQ_GC
.TP
.B EXP_RQ_REPLICATION
.RE
.TP
.I sp
is any number of space characters or tabs;
.TP
.I <working_directory>
is a working directory. Expertd changes to that directory just before
launching an external program;
.TP
.I <command_line>
is the last component on the line and is terminated by new line character.
.LP
For example:
.RS
.HP
EXP_RQ_FILESYSTEM   /etc/expert/  /usr/bin/clips -f bestfs.clp
.HP
EXP_RQ_MIGRATOR /etc/expert/  /usr/bin/clips -f migrator.clp
.HP
EXP_RQ_RECALLER /etc/expert/  /usr/bin/clips -f recaller.clp
.HP
EXP_RQ_GC /etc/expert/  /usr/bin/clips -f gc.clp
.HP
EXP_RQ_REPLICATION /etc/expert/  /usr/bin/clips -f replication.clp
.RE
.LP
The name of the configuration file can be defined also through the environment
variable
.B EXPERT_CONFIG
or via the entry in
.B /etc/castor/castor.conf:
.RS
.RS
.HP
EXPERT CONFIG /etc/sysconfig/expertd
.RE
.RE
.LP
If none of these methods is used, the name of the configuration file
is taken from the definition of ExpertConfig in site.def.
.SH FILES
.TP 1.5i
.B /etc/EXPCONFIG
- configuration file
.TP 1.5i
.B /var/log/castor/expertd.log
- log file
.fi
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
