.\" @(#)$RCSfile: deleteFileClass.man,v $ $Revision: 1.3 $ $Date: 2006/04/24 16:13:40 $ CERN IT/ADC Olof Barring
.\" Copyright (C) 2005 by CERN IT/ADC
.\" All rights reserved
.\"
.TH DELETEFILECLASS 1 "$Date: 2006/04/24 16:13:40 $" CASTOR "stager catalogue administrative commands"
.SH NAME
deleteFileClass \- deletes an existing file class in the stager catalogue
.SH SYNOPSIS
.B deleteFileClass
[
.BI -h, 
.BI --help
]
.BI --Name " name"
.SH DESCRIPTION
.B deleteFileClass
deletes an existing file class definition in the CASTOR stager catalogue
.LP
This command requires database client access to the stager catalogue
.TP
.BI \-h,
.BI \-\-help
Get usage information
.TP
.BI \-\-Name " name"
is the name of the file class to be deleted. An error is printed and the command
fails if no file class with that name is found
.TP
.LP
The CASTOR stager retrieves the fileclass name for a given CASTOR file from the
CASTOR name server. It does, however, only retrieve the name and will not use the
fileclass attributes as they are defined in the CASTOR name server. Instead the
FileClass together with the SvcClass attributes defined in the stager catalogue
are used to determine, for instance, how many copies and which tape pools should
be used when migrating the file to tape (see
.B NOTES
section below).
.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.
.SH SEE ALSO
.BR enterFileClass(1castor),
.BR modifyFileClass(1castor),
.BR printFileClass(1castor),
.BR adminMultiInstance(1castor)
.SH NOTES
The definition of FileClass and SvcClass classes in the stager catalogue is
an important change with the new CASTOR stager. The previous CASTOR stgdaemon,
toke the following important migration parameters from the CASTOR name server:
number of copies on tape, the tape pools to be used and the maximum number of
drives to be used when starting the migration streams. Those attributes are now
defined in the FileClass and SvcClass tables of the stager catalogue. The
basic motivation for this change was to be able to disentangle file attributes
such as number of tape copies from resource attributes such as how many drives
should be used for migration.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
