.\" @(#)$RCSfile: deleteSvcClass.man,v $ $Revision: 1.2 $ $Date: 2006/04/24 16:13:40 $ CERN IT/ADC Olof Barring
.\" Copyright (C) 2005 by CERN IT/ADC
.\" All rights reserved
.\"
.TH DELETESVCCLASS 1 "$Date: 2006/04/24 16:13:40 $" CASTOR "stager catalogue administrative commands"
.SH NAME
deleteSvcClass \- deletes an existing service class in the stager catalogue
.SH SYNOPSIS
.B deleteSvcClass
[
.BI -h, 
.BI --help
]
.BI --name " name"
.SH DESCRIPTION
.B deleteSvcClass
deletes an existing service class definition in the CASTOR stager catalogue
.LP
This command requires database client access to the stager catalogue
.TP
.BI \-h,
.BI \-\-help
Get usage information
.TP
.BI \-\-name " name"
is the name of the service class to be deleted. An error is printed and the command
fails if no file class with that name is found
.TP
.LP
Deletion of a service class removes the service class but not the associated disk and
tape pools from the catalog database. Any subsequent client stager request specifying
the removed service class will fail.
.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.
.SH SEE ALSO
.BR enterFileClass(1castor) ,
.BR modifyFileClass(1castor),
.BR adminMultiInstance(1castor)
.SH NOTES
The definition of FileClass and SvcClass classes in the stager catalogue is
an important change with the new CASTOR stager. The previous CASTOR stgdaemon,
toke the following important migration parameters from the CASTOR name server:
number of copies on tape, the tape pools to be used and the maximum number of
drives to be used when starting the migration streams. Those attributes are now
defined in the FileClass and SvcClass tables of the stager catalogue. The
basic motivation for this change was to be able to disentangle file attributes
such as number of tape copies from resource attributes such as how many drives
should be used for migration.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
