.\" @(#)$RCSfile: diskServer_qry.man,v $ $Revision: 1.5 $ $Date: 2006/08/04 14:46:47 $ CERN IT/ADC Olof Barring
.\" Copyright (C) 2005 by CERN IT/ADC
.\" All rights reserved
.\"
.TH DISKSERVER_QRY 1 "$Date: 2006/08/04 14:46:47 $" CASTOR "List files on a DiskServer"
.SH NAME
diskServer_qry
.SH SYNOPSIS
.B diskServer_qry
[
.B -h, 
.B --help
]
[
.B -i, 
.B --fileId
]
[
.B -d, 
.B --diskCopyId
]
diskServerName
.SH DESCRIPTION
.B diskServer_qry 
Lists the files on a given DiskServer and give their internal
status.

.TP 20
.B \-h,\ \-\-help
Get usage information
.TP
.B \-i,\ \-\-fileId
Prints the castor fileId and HSM name of each file
.TP
.B \-d,\ \-\-diskCopyId
Prints the diskCopyId of each file
.LP
.B diskServerName
is the name of the disk server to be queried


.SH EXAMPLES
.BI #\ diskServer_qry\ lxfsrk605
.fi
Status               Physical FileName
.fi
DISKCOPY_CANBEMIGR   /shift/lxfsrk605/data01/05/61263405@lxs5010.450
.fi
DISKCOPY_CANBEMIGR   /shift/lxfsrk605/data01/21/61270821@lxs5010.529
.fi
DISKCOPY_STAGEOUT    /shift/lxfsrk605/data01/46/61312846@lxs5010.718
.ft

.BI #\ diskServer_qry\ -id\ lxfsrk605
.fi
FileId     DiskCopyId   Status               Physical FileName                                  HSM FileName
.fi
61263405   450          DISKCOPY_CANBEMIGR   /shift/lxfsrk605/data01/05/61263405@lxs5010.450    /castor/cern.ch/some/hsm/path
.fi
61270821   529          DISKCOPY_CANBEMIGR   /shift/lxfsrk605/data01/21/61270821@lxs5010.529    /castor/cern.ch/some/hsm/path
.fi
61312846   718          DISKCOPY_STAGEOUT    /shift/lxfsrk605/data01/46/61312846@lxs5010.718    /castor/cern.ch/some/hsm/path
.ft
.fi
.SH NOTES
This command connects directly to the stager database through
the perl DBI interface to ORACLE. Thus it can only run on
a machine providing it.
Configuration for the database access is taken from castor.conf.

.SH SEE ALSO
.BR adminMultiInstance(1castor)

.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
