.\" @(#)$RCSfile: modifyFileClass.man,v $ $Revision: 1.4 $ $Date: 2008/06/02 13:31:55 $ CERN IT/ADC Olof Barring
.\" Copyright (C) 2005 by CERN IT/ADC
.\" All rights reserved
.\"
.TH MODIFYFILECLASS 1 "$Date: 2008/06/02 13:31:55 $" CASTOR "stager catalogue administrative commands"
.SH NAME
modifyFileClass \- modify an existing file class in the stager catalogue
.SH SYNOPSIS
.B modifyFileClass
[
.BI -h, 
.BI --help
]
.BI --Name " name"
[
.BI --GetFromCns
]
[
.BI --NsHost " nameServerHostName"
]
[
.BI --NbCopies " nbCopies"
]
.SH DESCRIPTION
.B modifyFileClass
modifies an existing file class definition in the CASTOR stager catalogue
.LP
This command requires database client access to the stager catalogue
.TP
.BI \-h,
.BI \-\-help
Get usage information
.TP
.BI \-\-Name " name"
is the name of the existing file class. An error is printed and the command
fails if no file class with the that name is found
.TP
.BI \-\-GetFromCns
Modifies the file class with attributes taken from the CASTOR name server.
An error is printed and the command fails if the file class is not defined
in the CASTOR name server. If this option is specified together with
options for setting attributes (e.g.
.B --NbCopies
), those latter will override the information taken from the name server.
.TP
.BI \-\-NsHost " nsHost"
Use the name server host
.IR nsHost
when retrieving the file class information. This option has only effect
together with the
.BI \-\-GetFromCns
switch.
.TP
.BI \-\-NbCopies " nbCopies"
Specifies the number of tape copies required for the CASTOR files belonging
to this file class
.LP
The CASTOR stager retrieves the fileclass name for a given CASTOR file from the
CASTOR name server. It does, however, only retrieve the name and will not use the
fileclass attributes as they are defined in the CASTOR name server. Instead the
FileClass together with the SvcClass attributes defined in the stager catalogue
are used to determine, for instance, how many copies and which tape pools should
be used when migrating the file to tape (see
.B NOTES
section below).
.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.
.SH EXAMPLES
.nf
.ft CW
modifyFileClass --Name cmsprod --NbCopies 2
.ft
.fi
.SH SEE ALSO
.BR enterFileClass(1castor),
.BR deleteFileClass(1castor),
.BR printFileClass(1castor),
.BR adminMultiInstance(1castor)

.SH NOTES
The definition of FileClass and SvcClass classes in the stager catalogue is
an important change with the new CASTOR stager. The previous CASTOR stgdaemon,
toke the following important migration parameters from the CASTOR name server:
number of copies on tape, the tape pools to be used and the maximum number of
drives to be used when starting the migration streams. Those attributes are now
defined in the FileClass and SvcClass tables of the stager catalogue. The
basic motivation for this change was to be able to disentangle file attributes
such as number of tape copies from resource attributes such as how many drives
should be used for migration.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
