.\" @(#)$RCSfile: nschown.man,v $ $Revision: 1.6 $ $Date: 2009/07/23 12:22:04 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1999-2003 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH NSCHOWN 1 "$Date: 2009/07/23 12:22:04 $" CASTOR "Cns User Commands"
.SH NAME
nschown \- change owner and group of a CASTOR directory/file in the name server
.SH SYNOPSIS
.B nschown
[\fIOPTION\fR]... \fIOWNER\fR[\fI:\fR[\fIGROUP\fR]] \fIPATH\fR...
.SH DESCRIPTION
.B nschown
sets the owner and optionally the group of a CASTOR directory/file in the name
server to the values in OWNER and GROUP respectively.
.LP
To change the owner ID, if the group ID does not change and if the caller and
the new owner ID belong to that group, GRP_ADMIN privilege are needed, otherwise
the caller must have ADMIN privileges in the Cupv database.
To change the group ID, the effective user ID of the process must match the
owner ID of the file and the new group must be in the list of groups the caller
belong to or the caller must have ADMIN privileges in the Cupv database.
.TP
.I OWNER
is either a valid username from the
.B passwd
file or a valid numeric ID.
.TP
.I GROUP
is either a valid group name from the
.B GROUP
file or a valid numeric ID.
.TP
.I PATH
specifies the CASTOR pathname. If PATH does not start with
.BR / ,
it is prefixed by the content of the
.B CASTOR_HOME
environment variable.
.SH OPTIONS
The following options are supported:
.TP
.B -h
If
.I PATH
is a symbolic link, changes the ownership of the link itself.
.TP
.B -R
Recursive mode.
.TP
.B \-\-help
Display this help and exit
.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.
.SH SEE ALSO
.BR Castor_limits(4) ,
.BR Cns_chown(3) ,
.BR Cupvlist(1) ,
.BR group(5) ,
.B passwd(1)
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
