.\" @(#)$RCSfile: killjid.man,v $ $Revision: 1.3 $ $Date: 2001/09/26 09:13:54 $ CERN IT-PDP/DM Olof Barring
.\" Copyright (C) 2000 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH KILLJID 1 "$Date: 2001/09/26 09:13:54 $" CASTOR "RTCOPY Operator Commands"
.SH NAME
killjid \- kill RTCOPY job running on local host
.SH SYNOPSIS
.B killjid
[
.BI -j
] [
.BI -r
] [
.BI jobID
]
.SH DESCRIPTION
.B killjid
attempts to kill the job specified with the
.B jobID
parameter. The
.B jobID
is the PID of a running RTCOPY process. On linux, becuase threads are
implemented as kernel processs, the
.B jobID
is normally the process group ID. If the job has a tape mounted (or
issued a request to mount a tape) the
.B jobID
can be found using the
.B tpstat
program.

The
.B -j
switch allows to specify the internal VDQM volume request ID rather
than the job ID (process group leader of a running job). This is useful
if the job has been stuck at an early stage, before the job ID has been
assigned. Use the
.B showqueues(1)
command with the
.B -j
switch to display the VDQM volume request ID.

The
.B -r
switch tells client to re-select another tape server. This could be
used to redirect running long requests from a server when an intervention
is needed. It could also be used if the request is stuck because a target
disk server did a reboot. 

.SH EXAMPLE
# tpstat
.nf
.ft CW
userid     jid  dgn        stat dvn                 rl  vsn    vid
                9840R3     idle 98403193@shd79                       
obarring 8244   9840R3     assn 98403194@shd79      oa*R01206 R01206 15:07:31
                9840R3     idle 98403195@shd79                       
.ft
.fi
# killjid -r 8244

.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.

.SH SEE ALSO
.B tpstat(1),
.B showqueues(1)
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
