.\" @(#)$RCSfile: Ctape_info.man,v $ $Revision: 1.8 $ $Date: 2001/09/26 09:13:55 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1994-2000 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH CTAPE_INFO 3 "$Date: 2001/09/26 09:13:55 $" CASTOR "Ctape Library Functions"
.SH NAME
Ctape_info \- get tape file information from header labels and mount requests;
get also information about the tape drive used.
.SH SYNOPSIS
.B #include <sys/types.h>
.br
\fB#include "Ctape_api.h"\fR
.sp
.BI "int Ctape_info (char *" path ,
.BI "int *" blksize ,
.BI "unsigned char *" blockid ,
.BI "char *" density ,
.BI "char *" devtype ,
.BI "char *" drive ,
.BI "char *" fid ,
.BI "int *" fseq ,
.BI "int *" lrecl ,
.BI "char *" recfm );
.SH DESCRIPTION
.B Ctape_info
gets the main characteristics of a tape file.
If a labelled tape is read and options are not set on the
.B Ctape_position
call, values are taken from the header labels.
The file id is of course only available for labelled tapes.
This command retrieves also the name and the type of the drive where the tape is
currently mounted and the density used (if known).
.TP
.I path
specifies the pathname relative to the current directory or the full pathname
which is used by the application program in the
.B open
statement. This path should have been created by Ctape_mount and used by
Ctape_position.
.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B serrno
is set appropriately.
.SH ERRORS
.TP 1.2i
.B SENOSHOST
Host unknown.
.TP
.B SENOSSERV
Service unknown.
.TP
.B SECOMERR
Communication error.
.TP
.B ETDNP
Tape daemon is not running.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
