.\" @(#)$RCSfile: Ctape_kill.man,v $ $Revision: 1.5 $ $Date: 2001/09/26 09:13:55 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1990-2000 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH CTAPE_KILL 3 "$Date: 2001/09/26 09:13:55 $" CASTOR "Ctape Library Functions"
.SH NAME
Ctape_kill \- cancel a running Ctape_mount or Ctape_position request.
.SH SYNOPSIS
.B #include <sys/types.h>
.br
\fB#include "Ctape_api.h"\fR
.sp
.BI "int Ctape_kill (char *" path );
.SH DESCRIPTION
.B Ctape_kill
cancels a running Ctape_mount or Ctape_position request.
.TP
.I path
specifies the pathname relative to the current directory or the full pathname
which is used by the application program in the
.B open
statement. This path should have been created by Ctape_mount or used by
Ctape_position.
.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B serrno
is set appropriately.
.SH ERRORS
.TP 1.2i
.B EINVAL
Bad parameter value.
.TP
.B SENOSHOST
Host unknown.
.TP
.B SENOSSERV
Service unknown.
.TP
.B SECOMERR
Communication error.
.TP
.B ETDNP
Tape daemon is not running.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
