.\" @(#)$RCSfile: Ctape_rls.man,v $ $Revision: 1.8 $ $Date: 2001/09/26 09:13:55 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1990-2000 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH CTAPE_RLS 3 "$Date: 2001/09/26 09:13:55 $" CASTOR "Ctape Library Functions"
.SH NAME
Ctape_rls \- release tape resources
.SH SYNOPSIS
.B #include <sys/types.h>
.br
\fB#include "Ctape_api.h"\fR
.sp
.BI "int Ctape_rls (char *" path ,
.BI "int " flags );
.SH DESCRIPTION
.B Ctape_rls
unloads the tape(s) used by the job, tells TMS that the tape
is free for use by other jobs, frees the corresponding tape drive(s)
and decrements the corresponding device group(s) reservation.
.TP
.I path
specifies the pathname relative to the current directory or the full pathname
which is used by the application program in the
.B open
statement.
.I path
should be either identical to the one specified on Ctape_mount or NULL.
The value of
.I path
is ignored if
.I flags
is set to
.BR TPRLS_ALL .
.TP
.I flags
may be a combination of the following:
.RS
.TP
.B TPRLS_ALL
releases all tape resources reserved by the job
.TP
.B TPRLS_PATH
releases an explicit path
.TP
.B TPRLS_KEEP_RSV
keeps reservation
.TP
.B TPRLS_NOUNLOAD
deassigns the drive but leaves the volume mounted
.TP
.B TPRLS_UNLOAD
always unloads the volume
.TP
.B TPRLS_NOWAIT
returns without waiting for the release to complete
.RE
.LP
If
.B TPRLS_ALL
is set,
.B TPRLS_PATH
and
.B TPRLS_KEEP_RSV
cannot be set.
.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B serrno
is set appropriately.
.SH ERRORS
.TP 1.2i
.B EINVAL
Bad parameter value.
.TP
.B SENOSHOST
Host unknown.
.TP
.B SENOSSERV
Service unknown.
.TP
.B SECOMERR
Communication error.
.TP
.B ETDNP
Tape daemon is not running.
.TP
.B ETRLSP
Release pending.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
