.\" @(#)$RCSfile: tape_oper.man,v $ $Revision: 1.6 $ $Date: 2001/09/26 09:13:56 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1996-2000 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH TAPE_OPER 1 "$Date: 2001/09/26 09:13:56 $" CASTOR "Ctape Administrator Commands"
.SH NAME
tape_oper \- operator interface to tape subsystem
.SH DESCRIPTION
Here is a list of messages sent to the
.B oper
display and the possible actions.
Each message is prefixed by a message number and a timestamp.
.LP
TP020 - mount tape 
.IR vid ( label_type )
.I ring_option
on drive
.IR drive_name @ hostname
for
.I username
.IR jid " (" reason )
or reply cancel | drive name
.RS
.I reason
is a null string in the normal case, but could be
.BR "wrong ring status" ,
.BR "wrong vsn" ,
.BR "reselect same" ,
.BR "reselect failed"
or
.BR "reselect" .
The operator or the robot must mount the tape or the operator may reply to
the message with the command
.B rep
giving the message number and the action.
.I action
must be:
.TP
.BI cancel " reason_for_cancel"
the user gets the
.I reason_for_cancel
message in his/her output;
the mount request is cancelled and the drive is freed.
.TP
.I drive_name
the mount request is cancelled on the original drive and reissued for the drive
.I drive_name
.TP
.B reselect server
the mount request is cancelled and the drive is freed but if the mount
was issued from rtcopy, a new tape server is selected automatically.
.RE
.LP
TP033 - drive
.IR drive_name @ hostname
not operational
.RS
This is an informative message. The drive is automatically configured down
and the request cancelled.
When the drive has been repaired, the command
.B tpconfig
can be used to reenable production on it.
.RE
.LP
TP041 - mount of
.I vid
on
.I drive_name
failed:
.I reason
.RS
This message is sent in case of robotic mount/demount failure.
For a mount failure, the possible actions are similar to the actions for TP020.
For a demount failure, the problem must be corrected or
.B cancel
must be entered.
.RE
.LP
TP062 - tape
.I vid
to be prelabelled has vsn
.IR vsn ,
ok to continue?
.LP
TP062 - tape
.I vid
to be prelabelled is an NL tape, ok to continue?
.RS
type "ok" or "yes" to continue, any other reply will cancel the prelabel.
.RE
.SH SEE ALSO
.BR oper (1),
.BR rep (1),
.BR tpconfig (1)
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
