.\" @(#)$RCSfile: tplabel.man,v $ $Revision: 1.9 $ $Date: 2007/12/04 08:51:51 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1990-2003 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH TPLABEL 1 "$Date: 2007/12/04 08:51:51 $" CASTOR "Ctape User Commands"
.SH NAME
tplabel \- initialize a new blank tape
.SH SYNOPSIS
.B tplabel
[
.BI -D " drive"
] [
.BI -d " density"
] [
.BI -g " device_group_name"
] [
.BI -H " number_headers"
] [
.BI -l " label_type"
] [
.B -T
] [
.BI -V " visual_identifier"
] [
.BI -v " volume_serial_number"
] [
.BI --nbsides " n"
] [
.B -f
]
.SH DESCRIPTION
.B tplabel
checks with VMGR if the tape is available and if the user
has write permission. It asks the operator or the robot to mount it write
enabled on a drive selected by the tape daemon or specified in the -D option.
When the tape is ready, it checks if the tape is blank (if not the operator will
be asked for confirmation). Then the tape daemon
rewinds it and writes VOL1 and HDR1 label records followed by one or two
tape marks for labelled tapes or only one or two tape marks for unlabelled
tapes.
By default, the number of tapemarks is one for tapes with directory such as DLT,
IBM 3590, Redwood and STK 9840, two tapemarks otherwise.
The option -T can be used to force two tapemarks to be written. 

With version 2.1.4 of CASTOR the message daemon has been removed. Hence, there
is no more interaction with an operator to confirm mounts or check labelling if
a tape already has a label. In order to prevent accidental labelling, the
default action if a already labelled tape is about to be labelled is to abort.
The -f option can override this behaviour and force a labelled tape to be 
labelled again.

.SH OPTIONS
.TP
.BI \-D " drive"
Explicit drive name.
.TP
.BI \-d " density"
.B 1600
or
.B 6250
for round (IBM 3420) tapes,
.B 38000
for standard IBM 3480 cartridges,
.B 38KC
for 3480 cartridges with compaction (IDRC),
.B 38KD
for double density IBM 3490 cartridges,
.B 38KDC
for 3490 cartridges with compaction (IDRC),
.BR 8200 ,
.BR 8200C ,
.B 8500
or
.B 8500C
for Exabytes,
.B DDS
or
.B DDSC
for DAT cartridges,
.BR 2G ,
.BR 6G ,
.BR 10G ,
.BR 10GC ,
.BR 20G ,
.BR 20GC ,
.BR 35G ,
.BR 35GC ,
.B 40G
or
.B 40GC
for DLT cartridges,
.B 10G
or
.B 10GC
for IBM 3590 cartridges,
.B 40G
or
.B 40GC
for IBM 3590E cartridges,
.BR 10G ,
.BR 10GC ,
.BR 25G ,
.BR 25GC ,
.B 50G
or
.B 50GC
for Redwood cartridges,
.B 20G
or
.B 20GC
for STK 9840 cassettes,
.B 60G
or
.B 60GC
for STK 9940 cartridges,
.B 100G
or
.B 100GC
for LTO cartridges.
It must match the density specified in VMGR (if installed).
.TP
.BI \-g " dgn"
The device group must be a member of an installation defined set of "device groups".
The list can be obtained with
.BR vmgrlistdgnmap .
It must match the device group specified in VMGR (if installed).
Default is CART.
.TP
.BI \-H " number_headers"
Defines the number of headers included in the prelabel: if
.BR 0 ,
only a VOL1 record is written; if
.BR 1 ,
VOL1 and HDR1 are written (this is the default); if
.BR 2 ,
VOL1, HDR1 and HDR2 are written to tape.
.TP
.BI \-l " lab_type"
Label type:
.BR al ,
.BR aul ,
.B nl
or
.BR sl .
It must match the label type specified in VMGR (if installed).
Default is sl.
.TP
.B \-T
Forces writing of 2 tapemarks at the end of a label.
.TP
.BI \-V " vid"
Specifies the tape visual identifier. It must be at most six characters long
and is converted to upper case.
.TP
.BI \-v " vsn"
Specifies the magnetically recorded volume serial number of the tape.
It must be at most six characters long and is converted to upper case.
The vsn must match the one specified in VMGR (if installed).
.TP
.BI \-\-nbsides " n"
Specifies the number of sides offered by the piece of media (for example a DVD).
Default is 1.
.TP
.B \-f
Forces labelling (even if the tape is labelled already).
.LP
VOL1 record structure:

1:4	"VOL1"
.br
5:10	vsn (maximum 6 characters in upper case).
.br
38:51	Owner (login name) for AL tapes.
.br
42:51	Owner (login name) for SL tapes.
.br
80	Label standard level 3 (AL tapes).

HDR1 record structure:

1:4	"HDR1"
.br
5:12	"PRELABEL"
.br
22:27	fsid (same as vsn)
.br
28:31	0001 (volume sequence number)
.br
32:35	0001 (file sequence number)
.br
36:39	0001 (generation number)
.br
40:41	00 (version number)
.br
42:47	today's date in Julian form (creation date)
.br
48:53	today's date in Julian form (expiration date)
.br
55:60	000000 (block count)
.br
61:73	system code ("CASTOR" followed by version number)
.SH EXIT STATUS
This program returns 0 if the operation was successful or >0 if the operation
failed.
.SH SEE ALSO
.B Ctape_label(3)
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
