.\" @(#)$RCSfile: usrlbl.man,v $ $Revision: 1.6 $ $Date: 2003/11/12 14:55:15 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1990-2003 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH USRLBL 3 "$Date: 2003/11/12 14:55:15 $" CASTOR "Ctape Library Functions"
.SH NAME
.B checkeofeov, wrthdrlbl, wrttrllbl, deltpfil
\- user callable routines to check/write tape labels
.SH SYNOPSIS
.BI "int checkeofeov (int " tapefd ,
.BI "char *" path )
.LP
.BI "int wrthdrlbl (int " tapefd ,
.BI "char *" path )
.LP
.BI "int wrttrllbl (int " tapefd ,
.BI "char *" path ,
.BI "char *" labelid ,
.BI "int " nblocks )
.LP
.BI "int deltpfil (int " tapefd ,
.BI "char *" path )
.SH DESCRIPTION
These routines check for EOF and EOV labels, get information from header labels
and write the labels on a tape, using the information stored by
.B Ctape_mount
and
.BR Ctape_position .
To check for EOF/EOV or write labels,
the tape file must have been previously open in the user program,
.I tapefd
being the file descriptor returned by the
.I open
statement.
.I path
specifies the pathname relative to the current directory or the full pathname
which is used by the application program in the
.B open
statement. This path should have been created by
.B Ctape_mount
and used by
.BR Ctape_position .
.LP
.B checkeofeov()
checks for EOF and EOV labels.
The function should be called when a tapemark is read.
It returns 0 for EOF, ETEOV for EOV or -1 in case of error.
.LP
.B wrthdrlbl()
writes the header labels on a tape.
Header labels consist of a VOL1 record for the first file and an HDR1 and HDR2
for all files on a labelled tape.
The tapemark which precedes the label group for all files, except the first,
is rewritten for Exabytes in 8200 mode.
The label group is ended by one tapemark.
For nl tapes, the tapemark is rewritten (Exabytes in 8200 mode only) if not
at beginning of tape.
The routine should be called after the open and before the first write
operation on the tape file.
.LP
.B wrttrllbl()
writes the trailer labels on a tape.
Trailer labels consist of a pair of records EOF1/EOF2 or EOV1/EOV2 for all files
on a labelled tape.
.I labelid
indicates EOF or EOV while
.I nblocks
should be set to the number of physical blocks written in the current file section.
The label group is preceded by one tapemark. It is followed by one tapemark on
tapes with directory such as DLT, 3590 and Redwood, two tapemarks otherwise.
For nl tapes, one or two tapemarks are written depending on device type.
The tape is then positioned after the tapemark on DLT/3590/Redwood, in front
of the two tapemarks on Exabytes in 8200 mode, between the two tapemarks
otherwise.
The routine should be called after the last write operation on the tape file
and before the close.
.LP
.B deltpfil()
may be called after
.B wrthdrlbl
and eventually some writes to delete the current file on the tape.
The tape is positionned back in front of the file label.
If the file is the first one on the tape, the header label is rewritten
with a retention period of 0, otherwise two tape marks are written over.
.SH RETURN VALUE
These routines return 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B serrno
is set appropriately.
.SH ERRORS
.TP 1.2i
.B ENOENT
.I path
not found.
.TP
.B EIO
I/O error.
.TP
.B EBADF
Bad file number.
.TP
.B ENOSPC
Tape full.
.TP
.B ETLBL
Bad label structure.
.TP
.B ETCOMPA
Drive/cartridge compatibility problem.
.TP
.B ETHWERR
Device malfunction.
.TP
.B ETPARIT
Parity error.
.TP
.B ETUNREC
Unrecoverable media error.
.TP
.B ETNOSNS
No sense data available.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
