.\" @(#)$RCSfile: wrttpmrk.man,v $ $Revision: 1.2 $ $Date: 2003/11/12 14:55:15 $ CERN IT-PDP/DM Jean-Philippe Baud
.\" Copyright (C) 1990-2003 by CERN/IT/PDP/DM
.\" All rights reserved
.\"
.TH WRTTPMRK 3 "$Date: 2003/11/12 14:55:15 $" CASTOR "Ctape Library Functions"
.SH NAME
wrttpmrk \- flush tape drive buffer or write tape marks
.SH SYNOPSIS
.BI "int wrttpmrk (int " tapefd ,
.BI "char *" path ,
.BI "int " n );
.SH DESCRIPTION
.B wrttpmrk
flushes the tape drive buffer or writes tape marks.
.TP
.I tapefd
being the file descriptor returned by the
.B open
statement.
.TP
.I path
specifies the pathname relative to the current directory or the full pathname
which is given by the application program in the
.B open
statement.
.I path
is only used for the error messages.
.TP
.I n
is the number of tape marks to be written. If
.I n
is zero or greater than 1, the tape drive buffer is flushed.
.SH RETURN VALUE
This routine returns 0 if the operation was successful or -1 if the operation
failed. In the latter case,
.B serrno
is set appropriately.
.SH ERRORS
.TP 1.2i
.B EIO
I/O error.
.TP
.B EBADF
Bad file number.
.TP
.B ETCOMPA
Drive/cartridge compatibility problem.
.TP
.B ETHWERR
Device malfunction.
.TP
.B ETPARIT
Parity error.
.TP
.B ETUNREC
Unrecoverable media error.
.TP
.B ETNOSNS
No sense data available.
.SH AUTHOR
\fBCASTOR\fP Team <castor.support@cern.ch>
